#DEFINE DEBUG

'#DEFINE quick_quit   'if defined, [Esc] key will exit current game


'
'
'
'
'
' nov 4
' around noon, my brother said ok for me to enter compo
' just combining & organizing useful sub routine and stuff
' added mono put
' added sound module
' still planning what to make...4 part game...
' invader, cave game, side shooter, fake 3D shooter... maybe too much...
'
' nov 5
' finished making sprite get
' added font drawing routine
' added mask put...maybe useful...
' added zerofill
' keep reducing game plan.
'
'
'nov 6
'making sample cave map. didnt finish adding spike. map seems too big.
'
'nov 7
'adjust smaller and more floor on screen approach
'will give up jump.
'simplify cave element
' remade cave area. simpliest. no more jump. breakable floor, and spike. for now.
'
'nov 8
'too tired. ZZZ
'
'nov 9
'started actual game menu engine.
'basic setup done
'basic map drawing
'
'started main game program
'
'nov 10
'maze scroll engine...hardcoded
'
'added sound
'added color
'add breakable tiles with puff-cloud
'
'made rough title screen
'invader part started
'

'nov 11
' wasted whole day on invader.
' finished title screen
' @night
' posted title screen and invader sample screen shot
' explanned font drawing routine
' will continue working on spike routine of cavedown...

'nov 12
'added spikes
'will work on 1) player hit by something or 2)enemy set Up/Down

'nov 13
'added cave. player hit, dead, blink
'added enemyA, enemyB
'move left / right for now (bounce)
'will add ground/ceiling detection
'
'nov 14.
'just added non-moving enemies

'nov 15
'enemy part done. boing boing too.
'will work on cut scene now
' tomorrow = final showdown

'nov 16
'cave part almost done.
'added ufo.
'spike done.
'multiput cave drawing routine was slow, changed with another way.
'rough cutscene mockup
'
'greyfox came to my house, looked at my program.
'distracting me with 2 gamecube games he brought.
'he was distracted by 1/4 kyon's sister figure. LOL.
'
'working on ufo storage area. need to clean up the map

'nov 17....
'log...no time!
'
'nov 18
'adding quit menu , also made it toggle-able for speed up
'adding final game
'added warning (darius type)
'errr. notime for log writing...
'
'


#INCLUDE "sound_module.bas"
#INCLUDE "multiput.bas"
#INCLUDE "multiput_addon.bas"
#INCLUDE "fbgfx.bi"


#IFNDEF TRUE
CONST FALSE = 0
CONST TRUE = NOT FALSE
#ENDIF
#define ZEROFILL(VARNAME, NUMDIGIT) (RIGHT(STRING(NUMDIGIT - 1, "0" ) & VARNAME, NUMDIGIT))

USING FB

OPEN cons FOR OUTPUT AS #2 'for message log

ENUM cave_tile        '(wall.space.floor.spike) each bits
cave_space        = &b000000001
cave_wall         = &b000000010
cave_floor        = &b000000100
cave_spike        = &b000001000
cave_breakable    = &b000010000
cave_background   = &b000100000
cave_UFO          = &b001000100
cave_room         = &b110000000
cave_above_ground = &b100000000
END ENUM

ENUM gametype
phase_invader
phase_cavedown
phase_phoenix
END ENUM

ENUM gameresult    'result from each phase-game
flag_nothing  =0
flag_gameover =1
flag_win      =2
flag_quit     =4
END ENUM

TYPE puff_type
   used  AS INTEGER
   x     AS INTEGER
   y     AS INTEGER
   style AS INTEGER
   delay AS INTEGER
   zoom AS SINGLE
END TYPE

CONST max_puff = 16

DECLARE SUB TEXTDRAW (BYVAL x AS INTEGER = 0 , BYVAL y AS INTEGER = 0, BYVAL text AS STRING, BYVAL ColorKey AS INTEGER = &h000000, BYVAL border AS INTEGER = TRUE)

DECLARE SUB SAVE_HISCORE(BYVAL hiscore AS INTEGER)'copied from crane game
DECLARE SUB LOAD_HISCORE(BYREF hiscore AS INTEGER)

DECLARE SUB GET_SPRITES()
DECLARE SUB MAKE_CAVE_MAP()
DECLARE SUB DRAW_MINI_MAP(BYVAL scroll_y AS INTEGER, BYVAL shake AS INTEGER = FALSE)
DECLARE SUB CUTSCENE(BYVAL scene_number AS INTEGER = 0)

DECLARE SUB ADD_PUFF(BYVAL x AS INTEGER, BYVAL y AS INTEGER, BYVAL style AS INTEGER = 255)
DECLARE SUB DRAW_PUFF(BYVAL scroll_y AS INTEGER = 0)

DECLARE SUB TITLE(BYREF result AS INTEGER)
DECLARE SUB ASK_CONTINUE(BYREF result AS INTEGER)
DECLARE SUB ASK_QUIT(BYREF result AS INTEGER)
DECLARE SUB GAME_INVADER (BYREF result AS INTEGER)
DECLARE SUB GAME_CAVEDOWN (BYREF result AS INTEGER)
DECLARE SUB GAME_PHOENIX (BYREF result AS INTEGER)

DECLARE SUB DEMO()

DIM SHARED resource_graphic AS ANY PTR 'whole tileset
DIM SHARED sprite_buffer(20) AS ANY PTR 'added extra border for using with multiput zoom
DIM SHARED AS ANY PTR wall_buffer, floor_buffer, spike_buffer



DIM SHARED cave_map(19,500) AS USHORT

DIM SHARED AS puff_type puff(MAX_PUFF)

DIM SHARED AS INTEGER vis_page=0, work_page=1, credit, score, hiscore

DIM colorkey AS INTEGER 'for changing sprite color
DIM keypress AS STRING  'user input (INKEY)
DIM AS INTEGER i, j, k, mx,my,mw,mbtn

DIM AS INTEGER quit_game, game_phase, game_result, game_continue

RANDOMIZE TIMER

SCREEN 14 , 32, 2, 1 '320x240, hicolor, 2 pages, full screen
SETMOUSE ,,0


' FMOD initialization
INITIALIZE_SOUND

' load graphic
resource_graphic  = IMAGECREATE(128, 64)
BLOAD "graphics\graphics.bmp", resource_graphic
PSET resource_graphic, (12, 3), &hffffff  'fix the squid alien's eye on original source graphic
'PSET resource_graphic, (123, 15), &hffffff  'fix the missing pixel of jigjag laser on original source graphic

'get sprites individualy for zooming (empty border is needed for zooming with multiput)
GET_SPRITES()


LOAD_HISCORE(hiscore)
'do some one time init

DO

   credit = 3
   TITLE(quit_game)

   IF NOT quit_game THEN 'new game begin

      'new game init. score. credit etc

      score = 0 'no need to do. do it in the actual game

      game_phase = phase_invader
      'game_phase = phase_cavedown
      'game_phase = phase_phoenix

      credit -= 1   'new game. coin is used

      'big invader
      IF game_phase = phase_invader  THEN 'play inveder
         GAME_INVADER(game_result) 'exit condition = all dead or quit (esc) or win
         IF  game_result = flag_win THEN game_phase = phase_cavedown
      END IF

      'cave game
      IF game_phase = phase_cavedown THEN 'cave game
         GAME_CAVEDOWN(game_result) 'exit condition = all dead or quit (esc) or win
         IF  game_result = flag_win THEN game_phase = phase_phoenix
      END IF

      'final showdown
      IF game_phase = phase_phoenix THEN 'final showdown
         GAME_PHOENIX(game_result) 'exit cond = all dead or quit (esc) or win
         'IF  game_result = flag_win THEN game_next_game
      END IF

   END IF

   'ready to go back to TITLE screen

LOOP UNTIL quit_game

SCREENRES 640,480
SLEEP 500,1

END








'--- end of main program ---
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------


SCREENRES 640,480',,,1
SLEEP 500,1

END

SUB CLEAN_UP DESTRUCTOR
   FOR i AS INTEGER = 0 TO 20
      IMAGEDESTROY(sprite_buffer(i))
   NEXT
   IMAGEDESTROY(resource_graphic)
   IMAGEDESTROY(wall_buffer)
   IMAGEDESTROY(floor_buffer)
   IMAGEDESTROY(spike_buffer)
END SUB

SUB SAVE_HISCORE(BYVAL  hiscore AS INTEGER)
   OPEN "hiscore.txt" FOR OUTPUT AS #1
   PRINT #1, "hi-score"
   PRINT #1, hiscore
   CLOSE #1
END SUB

SUB LOAD_HISCORE(BYREF hiscore AS INTEGER)

   DIM AS INTEGER hiscore_filesize
   DIM AS STRING dummy_string

   'check if there is hi-score file
   OPEN "hiscore.txt" FOR APPEND AS #1
   hiscore_filesize = LOF(1)
   CLOSE #1

   'if not found then initialize with 1000 pts
   IF hiscore_filesize = 0 THEN
      hiscore = 1000
      SAVE_HISCORE(hiscore)
   ELSE 'if found then load it from file
      OPEN "hiscore.txt" FOR INPUT AS #1
      INPUT #1, dummy_string
      INPUT #1, hiscore
      CLOSE #1
   END IF
END SUB

SUB GET_SPRITES ()
   'add empty border for zooming with multiput

   '0, 1 alien a (8x8)
   sprite_buffer(0) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(0), (1, 1), resource_graphic, (8, 0)-(8 + 7, 0 + 7), PSET
   sprite_buffer(1) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(1), (1, 1), resource_graphic, (8, 8)-(8 + 7, 8 + 7), PSET

   '2, 3 alien b (16x8)
   sprite_buffer(2) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(2), (1, 1), resource_graphic, (16, 0)-(16 + 15, 0 + 7), PSET
   sprite_buffer(3) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(3), (1, 1), resource_graphic, (16, 8)-(16 + 15, 8 + 7), PSET

   '4, 5 alien c (16x8)
   sprite_buffer(4) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(4), (1, 1), resource_graphic, (32, 0)-(32 + 15, 0 + 7), PSET
   sprite_buffer(5) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(5), (1, 1), resource_graphic, (32, 8)-(32 + 15, 8 + 7), PSET

   '6 UFO (16x8)
   sprite_buffer(6) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(6), (1, 1), resource_graphic, (48, 0)-(48 + 15, 0 + 7), PSET

   '7 tank (16x8)
   sprite_buffer(7) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(7), (1, 1), resource_graphic, (48, 8)-(48 + 15, 8 + 7), PSET

   '8 laser (8x8)
   sprite_buffer(8) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(8), (1, 1), resource_graphic, (0, 8)-(0 + 7, 8 + 7), PSET

   '9,10,11 jigjag laser (8x8)
   sprite_buffer(9) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(9), (1, 1), resource_graphic, (64, 0)-(64 + 7, 0 + 7), PSET
   sprite_buffer(10) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(10), (1, 1), resource_graphic, (120, 0)-(120 + 7, 0 + 7), PSET
   sprite_buffer(11) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(11), (1, 1), resource_graphic, (120, 8)-(120 + 7, 8 + 7), PSET

   '12,13,14 + laser (8x8)
   sprite_buffer(12) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(12), (1, 1), resource_graphic, (64, 8)-(64 + 7, 8 + 7), PSET
   sprite_buffer(13) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(13), (1, 1), resource_graphic, (72, 8)-(72 + 7, 8 + 7), PSET
   sprite_buffer(14) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(14), (1, 1), resource_graphic, (80, 8)-(80 + 7, 8 + 7), PSET

   '15,16  shield eater explosion(8x8)
   sprite_buffer(15) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(15), (1, 1), resource_graphic, (112, 0)-(112 + 7, 0 + 7), PSET
   sprite_buffer(16) = IMAGECREATE(10+1, 10)
   PUT sprite_buffer(16), (1, 1), resource_graphic, (112, 8)-(112 + 7, 8 + 7), PSET

   '17  UFO explosion(16x8)
   sprite_buffer(17) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(17), (1, 1), resource_graphic, (72, 0)-(72 + 15, 0 + 7), PSET

   '18,19 tank explosion(16x8)
   sprite_buffer(18) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(18), (1, 1), resource_graphic, (8, 48)-(8 + 15, 48 + 7), PSET
   sprite_buffer(19) = IMAGECREATE(18+1, 10)
   PUT sprite_buffer(19), (1, 1), resource_graphic, (24, 48)-(24 + 15, 48 + 7), PSET

   '20 shield(24x16)
   sprite_buffer(20) = IMAGECREATE(26+1, 18)
   PUT sprite_buffer(20), (1, 1), resource_graphic, (88, 0)-(88 + 23, 0 + 17), PSET

   'for speed up in cave background, make bigger tile
   'wall_buffer, floor_buffer, spike_buffer
   wall_buffer = IMAGECREATE (19+1,43)
   MULTIPUT (wall_buffer,9,03+ 3, sprite_buffer(20), .8 , .6, 0, 253 )
   MULTIPUT (wall_buffer,9,03+14, sprite_buffer(20), .8 ,  2, 0, 253 )
   MULTIPUT (wall_buffer,9,03+27, sprite_buffer(20), .8 , .6, 0, 253 )
   MULTIPUT (wall_buffer,9,03+35, sprite_buffer(20), .8 , .6, 0, 253 )
   PSET wall_buffer,(16,2),&HFF00ff

   floor_buffer = IMAGECREATE(17+2,11)
   MULTIPUT (floor_buffer,   8,  5, sprite_buffer(20), .8 , .6, 0, 253)
   PSET floor_buffer,(16,1),&HFF00FF

   spike_buffer = IMAGECREATE(9,9)
   MULTIPUT (spike_buffer,   4,  4, sprite_buffer(0), .8 , 1, 180, 253)



END SUB
SUB TEXTDRAW ( _
   BYVAL x AS INTEGER = 0 , _
   BYVAL y AS INTEGER = 0, _
   BYVAL text AS STRING, _
   BYVAL ColorKey AS INTEGER = &h000000, _
   BYVAL border AS INTEGER = TRUE)

   DIM AS INTEGER number_of_letter, i, ascii, row, column

   number_of_letter = LEN(text)
   IF number_of_letter >0 THEN
      FOR i = 0 TO number_of_letter - 1
         ascii = ASC(UCASE(text), i + 1)
         row = (ascii \ 16) * 8
         column = (ascii MOD 16)*8

         IF border THEN 'draw border
            PUT (x + i * 8+1, y), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
            PUT (x + i * 8-1, y), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
            PUT (x + i * 8, y+1), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
            PUT (x + i * 8, y-1), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
            PUT (x + i * 8+1, y-1), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
            PUT (x + i * 8+1, y+1), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
            PUT (x + i * 8-1, y+1), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
            PUT (x + i * 8-1, y-1), resource_graphic, (column, row)-(column + 7, row + 7),trans', custom, @CUSTOM_MONO_PUT, @colorkey
         END IF

         PUT (x + i * 8, y), resource_graphic, (column, row)-(column + 7, row + 7), custom, @CUSTOM_MONO_PUT, @colorkey
      NEXT
   END IF
END SUB
SUB MAKE_CAVE_MAP()
   'add less hole, spike, breakable floor as goes deeper

   DIM AS INTEGER i, j, done, floor_offset, ufo = 100

   'make new map
   FOR j = 0 TO 500
      FOR i = 0 TO 19
         cave_map(i, j) = cave_background
      NEXT
   NEXT

   'make ground
   FOR j = 0 TO 3
      FOR i = 0 TO 19
         cave_map(i, j) = cave_above_ground
      NEXT
   NEXT
   cave_map(3,3) = cave_room

   FOR i=0 TO 19
      cave_map(i, 4) = cave_floor
   NEXT
   cave_map(9, 4) = cave_wall OR cave_floor
   cave_map(10, 4) = cave_space
   cave_map(11, 4) = cave_wall OR cave_floor

   cave_map(4, 5) = cave_wall OR cave_floor
   FOR i=5 TO 15
      cave_map(i, 5) = cave_floor
   NEXT
   cave_map(16, 5) = cave_wall OR cave_floor
'   cave_map(10, 5) = cave_space
   cave_map(10, 5) = cave_floor OR cave_spike OR cave_breakable

   floor_offset = 4
   FOR j = 6 TO 500

      floor_offset += INT(RND(1) * 3) - 1
      IF floor_offset < 1 THEN floor_offset = 1
      IF floor_offset > 6 THEN floor_offset = 6

      IF j=ufo+3 THEN floor_offset = 3

      cave_map(floor_offset, j)= cave_wall OR cave_floor
      FOR i = floor_offset + 1 TO floor_offset + 11
         cave_map(i, j) = IIF (RND(1) > .2, cave_floor, (cave_spike OR cave_floor))
         IF RND(1)<.2 THEN cave_map(i, j) OR= cave_breakable
      NEXT
      cave_map(floor_offset + 12, j) = cave_wall OR cave_floor



      'add holes max 5
      FOR i = 0 TO INT(RND(1)*5) 'decrease as goes = challenging.
         cave_map(floor_offset + 2 + INT(RND(1)*9) ,j)= cave_space
      NEXT

      IF j=6 AND (cave_map( 10, j) AND cave_space) THEN
         cave_map( 10, j) = cave_floor
         cave_map( 11, j) = cave_space
      END IF



      IF j=ufo THEN
         cave_map(0,j)= cave_wall
         FOR i=1 TO 18
            cave_map(i,j) = cave_floor
         NEXT
         cave_map(19,j)= cave_wall
         cave_map(9,j) = cave_space
      END IF
      IF j=ufo+1 THEN FOR i=0 TO 19: cave_map(i,j) = cave_space: NEXT
      IF j=ufo+2 THEN FOR i=0 TO 19: cave_map(i,j) = cave_space: NEXT

      IF j=ufo+3 THEN
         cave_map(6,j) = cave_space
         FOR i=0 TO 19
            cave_map(i,j) = cave_floor
         NEXT
         cave_map(3,j) = cave_wall
         cave_map(15,j) = cave_wall
         cave_map(6,j) = cave_space
         cave_map(12,j) = cave_space
         cave_map(9,j) = cave_UFO
      END IF





   NEXT





END SUB
SUB TITLE(BYREF result AS INTEGER)
   DIM AS STRING userinput
   DIM AS INTEGER i



   CLS

   FOR i=0 TO 240
      LINE(0,i)-(319,i),&h000000 OR i
   NEXT

   TEXTDRAW 8,3, "SCORE  " & zerofill( score,8) & "     HI SCORE  " & zerofill( hiscore,8), 0


   TEXTDRAW 11*8,6*8, "I N V A D E R - FB", 0
   TEXTDRAW 12*8+4,10*8, "THE FINAL STORY", 0
   TEXTDRAW 8*8,23*8, "PRESS SPACE KEY TO START",&hffffff,FALSE
   TEXTDRAW 1*8,28*8, "Jaws-V soft .2007",&hffffff,FALSE
   TEXTDRAW 13*8,28*8, "c"
   TEXTDRAW 29*8,28*8, "credit " & zerofill( credit,2), 0

   TEXTDRAW 16*8+2,11*8, CHR(15),&hffffff, FALSE
   TEXTDRAW 16*8+2,12*8, CHR(15),&hffffff, FALSE
   TEXTDRAW 16*8+2,13*8, CHR(15),&hffffff, FALSE
   TEXTDRAW 16*8+2,14*8, CHR(15),&hffffff, FALSE
   TEXTDRAW 16*8+2,15*8, CHR(15),&hffffff, FALSE
   TEXTDRAW 16*8+2,16*8, CHR(15),&hffffff, FALSE
   TEXTDRAW 16*8-2,(15+2)*8, "--"',&hffffff, false

   TEXTDRAW 15*8-2,(16+2)*8-4, "/  \"',&hffffff, FALSE 'tank
   TEXTDRAW 15*8-2,(17+2)*8-4, "\  /"',&hffffff, FALSE 'tank

   TEXTDRAW 15*8+6,(18+2)*8+2, CHR(22,23),&hffff00, FALSE 'tank

   TEXTDRAW 22*8+4,(17+2)*8, "__"&CHR(13), &hffffff
   TEXTDRAW 22*8+4,(18+2)*8+2, "o o"', &hffffff, false


   DO
      userinput = INKEY
      SLEEP 1, 1
   LOOP UNTIL INSTR(CHR(32,27), userinput)

   IF userinput = CHR(32) THEN
      play_wav 3,3,255
   END IF

   result = userinput = CHR(27)

END SUB
SUB ASK_CONTINUE(BYREF result AS INTEGER)
   DIM AS STRING user_input

   'check credit then exit whatever
   
   IF score = hiscore THEN SAVE_HISCORE(hiscore)
   
   SCREENSET 0,0

   'TEXTDRAW 29*8,28*8, "credit " & zerofill( credit,2), 0    'no need

   IF credit>0 THEN
      TEXTDRAW 88,110, " continue? (Y/N) ", 0

      DO

         user_input = UCASE(INKEY)

         SLEEP 1,1
      LOOP UNTIL INSTR("YN"+CHR(27), user_input)
   ELSE
      SLEEP 2000, 1
   END IF

   result = user_input = "Y"

   IF result THEN
      credit -= 1
      score = 0
      play_wav 3,3,255
   END IF

END SUB

SUB DRAW_MINI_MAP(BYVAL scroll_y AS INTEGER, BYVAL shake AS INTEGER = FALSE)
   DIM AS INTEGER map_grid_y, sx = 0, sy = 0
   DIM AS INTEGER i,j,colorkey
   DIM AS INTEGER rr,gg,bb

   IF shake THEN
      sx = (INT(RND(1)*3)-1)*2 'shake x
      sy = INT(RND(1)*3)-1 'shake y
      'sy = -1
   END IF

   map_grid_y = scroll_y \ 32

   IF map_grid_y < 0 THEN map_grid_y = 0
   IF map_grid_y > 300 THEN map_grid_y = 300

   'CLS
   LINE(0,0)-(319,239), &h202020,bf

   FOR j = map_grid_y TO map_grid_y + 8

      gg=10

      ' LINE(0,(scroll_y \ 24)*j)-(320,(scroll_y \ 24)*j), &hffffff,b

      FOR i = 0 TO 19
         'background above ground
         IF (cave_map(i,j) AND cave_above_ground) THEN
            LINE(sx+i*16-4,sy+j*32+00-scroll_y)-(sx+i*16+15+4,sy+j*32+00+32-scroll_y),&h5050a0,bf
         END IF

         'secret room
         IF (cave_map(i,j) = cave_room) THEN
            LINE(sx+i*16-5-4,sy+j*32+00-scroll_y+5)-(sx+i*16+25-4,sy+j*32+00+33-scroll_y),&h202020,bf
            LINE(sx+i*16-5-4,sy+j*32+00-scroll_y+5)-(sx+i*16+15-4,sy+j*32+00+33-scroll_y),&h0,b
            LINE(sx+i*16+5-4,sy+j*32+00-scroll_y+5)-(sx+i*16+ 5-4,sy+j*32+00+33-scroll_y),&h0,b
            
            textdraw(sx+70,sy+70-scroll_y, "press space key to stomp")
         END IF

         'spike
         IF (cave_map(i,j) AND cave_spike) THEN
            colorkey = &hff0000
            'MULTIPUT (,sx+i*16+7-1+2,sy+j*32+9-scroll_y, sprite_buffer(1-1), .8, 1, 180, 253, @CUSTOM_MONO_PUT, @colorkey)
            PUT (sx+i*16+7-1+1-4, sy+j*32+9-4-scroll_y), spike_buffer, custom, @CUSTOM_MONO_PUT, @colorkey
         END IF

         'draw floor
         IF (cave_map(i,j) AND cave_floor) THEN
            gg = -10 - (ABS(i-10) *24)
            colorkey = &hf00000 OR gg SHL 8  OR    (ABS ((j MOD 8) -4 ) ) * 50

            PUT (sx+i*16-2,sy+j*32-2-scroll_y), floor_buffer, custom, @CUSTOM_MONO_PUT, @colorkey
         END IF


         'breakable floor
         IF (cave_map(i, j) AND cave_breakable) THEN
            colorkey = &h0
            MULTIPUT (,sx+i*16+ 3+4,sy+j*32+1-scroll_y, sprite_buffer(9), 1, 1, 0, 253, @CUSTOM_MONO_PUT, @colorkey)
         END IF

         'UFO
         IF (cave_map(i,j) = cave_UFO) THEN
            'colorkey = INT(RND(1)*&hffffff)
            colorkey = &hdddddd
            MULTIPUT (,sx+i*16+ 3+4,sy+j*32+1-scroll_y+19-42, sprite_buffer(6), 4, 4, 0, 253, @CUSTOM_MONO_PUT, @colorkey)
         END IF

         'draw wall
         IF (cave_map(i,j) AND cave_wall) THEN
            gg = -10 - (ABS(i-10) *24)
            colorkey = &hf00000 OR gg SHL 8  OR (ABS ((j MOD 8) -4 ) ) * 50
            PUT(sx+i*16-2,sy+j*32-3-scroll_y), wall_buffer, custom, @CUSTOM_MONO_PUT, @colorkey

            #IFDEF DEBUG
            'debug - display floor number
            IF i<9 AND ((j MOD 5 = 4) OR j=5)THEN TEXTDRAW sx+i*16+8+7-23,sy+j*32+20+1-scroll_y, zerofill(j-4,3), &hFF0000
            #ENDIF
         END IF


      NEXT

   NEXT

END SUB










SUB GAME_INVADER(BYREF result AS INTEGER)

   TYPE player_type 'make it local for now

      state AS INTEGER
      x AS INTEGER
      y AS INTEGER
      rest AS INTEGER
      control AS INTEGER
      speed AS INTEGER
      anim_pattern AS INTEGER
      old_anim_pattern AS INTEGER
      delay AS INTEGER 'all purpose...whatever....
      boing AS SINGLE

      shot_fired AS INTEGER
      shot_x AS INTEGER
      shot_y AS INTEGER

   END TYPE

   TYPE enemy_type
      used AS INTEGER
      state AS INTEGER
      x AS INTEGER
      y AS INTEGER
      kind AS INTEGER
      life AS INTEGER
      anim_pattern AS INTEGER
      anim_pattern_delay AS INTEGER
      armor AS INTEGER
      boing AS SINGLE
   END TYPE

   '   TYPE puff_type
   '      used AS INTEGER
   '      x AS INTEGER
   '      y AS INTEGER
   '      style AS INTEGER
   '      zoom AS SINGLE
   '      delay AS INTEGER
   '   END TYPE

   TYPE enemy_shot_type
      used AS INTEGER
      x AS INTEGER
      y AS INTEGER
      anim_pattern AS INTEGER
      anim_pattern_delay AS INTEGER
      anim_delay AS INTEGER
   END TYPE



   ENUM player_state
   st_init
   st_walk_in
   st_normal
   st_dead
   END ENUM
   ENUM enemy_state
   st_EN_init
   st_EN_move_sideway
   st_EN_move_down
   st_EN_go_back
   st_EN_dead
   END ENUM

   ENUM enemy_kind
   squid_kind = 0
   spider_kind = 2
   octopus_kind = 4
   END ENUM



   'CONST MAX_puff = 16
   CONST MAX_enemy = 16
   CONST MAX_enemy_shot = 4

   DIM AS player_type player
   DIM AS enemy_type enemy(MAX_enemy)
   'DIM AS puff_type puff(MAX_puff)
   DIM AS enemy_shot_type enemy_shot(MAX_enemy_shot)

   DIM AS INTEGER invader_color(2) = {&hc00000, &hff7f00, &h00c000}
   DIM AS INTEGER rr,gg,bb,i, j, game_continue, colorkey, enemy_direction = 1, free_slot_found
   DIM AS INTEGER enemy_anim_pattern_changed , enemy_walk_sound = 0, group_hit_wall, btn_hold
   DIM AS INTEGER enemy_remain, enemy_speed, game_state = 0, game_state_delay = 0
   DIM AS STRING user_input



   'load hiscore A
   'Hiscore = 3000

   DO 'new game or CONTINUE
      game_continue = FALSE
      game_state = 0

      'new game init
      result = flag_nothing 'nothing happened yet
      FOR i=0 TO MAX_PUFF
         puff(i).used = FALSE
      NEXT

      score = 0

      'rest. score. stage init
      player.rest = 3
      player.x=100
      player.y = 206
      player.state = st_walk_in
      player.anim_pattern = 0

      'enemy init
      enemy_remain = 12
      enemy_speed = 1
      FOR j=0 TO 2
         FOR i=0 TO 3
            enemy(j*4+i).used = TRUE
            enemy(j*4+i).x = i*55+40
            enemy(j*4+i).y = 20 + j*40
            enemy(j*4+i).kind = squid_kind + j*2
            enemy(j*4+i).armor = invader_color(j)
            enemy(j*4+i).state = st_EN_init
            enemy(j*4+i).anim_pattern = 0
            enemy(j*4+i).anim_pattern_delay = 0
         NEXT
      NEXT




      DO
         SCREENSET work_page, vis_page

         'CLS'
         RR = 127 - 63
         GG = 195 -63
         BB = 255-63

         FOR i=0 TO 23
            rr -= 2: gg -= 2: bb -= 8
            LINE(0,i*10)-(319,i*10+9), RGB(RR,GG,BB), bf
         NEXT


         IF MULTIKEY(SC_ESCAPE) THEN result = flag_quit


         'before win or lose the game, wait a few moment and display some stuff first
         IF player.state = st_normal THEN
            SELECT CASE game_state ' = flag_win THEN
               CASE flag_win
                  game_state_delay += 1

                  'add some cool WIN stuff on screen using delay value...whatever
                  'maybe score = REST x 1000 pts...
                  IF player.rest > 0 THEN
                     IF game_state_delay = 20 THEN
                        'score calculation
                        score += player.rest * 100
                        IF score>hiscore THEN hiscore = score
                     END IF
                     IF game_state_delay > 20 THEN
                        TEXTDRAW 120,90, "B O N U S", &hffff00, FALSE
                        TEXTDRAW 100,110, CHR(22,23) , &hffff00, FALSE
                        TEXTDRAW 116,110,  " x 100 = " & player.rest*100 , 0
                     END IF
                  END IF




                  IF game_state_delay > 100 THEN 'wait enough then 'set result flag to flag_WIN to this game
                     result = flag_win
                  END IF
               CASE flag_gameover 'errr... not used
 
            END SELECT
         END IF


         '---< T A N K  F I R E  checking >---
         'if space key then shake the screen!
         IF MULTIKEY(SC_SPACE) AND NOT btn_hold THEN
            IF player.state = st_normal THEN
               'check if shot is already fired
               IF NOT player.shot_fired THEN
                  player.shot_fired = TRUE
                  player.shot_x = player.x
                  player.shot_y = player.y-10
                  play_wav 1, 1,255 'tank fire sound
               END IF

            END IF
         END IF
         btn_hold = MULTIKEY(SC_SPACE)


         '---< P L A Y E R >---
         SELECT CASE player.state
            CASE st_walk_in 'walk in from out of screen...

               player.state = st_normal

            CASE st_normal 'normal game
               IF MULTIKEY(SC_LEFT) THEN
                  player.x -= 6
                  IF player.x <= 30-10 THEN player.x = 30-10
               END IF

               IF MULTIKEY(SC_RIGHT) THEN
                  player.x += 6
                  IF player.x >= 290+10 THEN player.x = 290+10
               END IF


            CASE st_dead 'boom for a few moments
               'delay counter ++
               'add boom manually
               'then at the end, decrease REST
               'set same position. (no change)
               'back to action

               player.delay += 1

               'set player animation pattern manually to boomA and boomB . no time to do other way
               IF player.delay MOD 4 = 0 THEN player.anim_pattern = 11
               IF player.delay MOD 4 = 2 THEN player.anim_pattern = 12


               IF player.delay >= 60 THEN    'boom has ended. decrease REST. get ready for next round.

                  'maybe set player to out of screen just in case

                  player.rest -= 1

                  IF player.rest <0 THEN
                     result = flag_gameover
                  ELSE
                     player.state = st_normal
                     player.anim_pattern = 0

                  END IF

               END IF

         END SELECT

         colorkey = &hffff00
         MULTIPUT (,player.x, player.y, sprite_buffer(7+player.anim_pattern), 3 , 3, 0 , 253, @CUSTOM_MONO_PUT, @colorkey)
         'PSET(player.x, player.y):DRAW"NU3NR3ND3NL3"
         'LINE(player.x-21, player.y)-(player.x+18, player.y+15), &hff0000,b


         '---<  T A N K  S H O T  processing >---
         IF player.shot_fired THEN

            player.shot_y -= 6

            IF player.shot_y < -10 THEN
               player.shot_fired = FALSE
            ELSE
               FOR i=0 TO MAX_enemy 'then check hit with all enemy
                  IF enemy(i).used THEN  'only live one
                     IF player.shot_fired THEN ' and only while shot is on screen
                        IF (player.shot_x >= enemy(i).x-20) AND _
                           (player.shot_x <= enemy(i).x+20) AND _
                           (player.shot_y >= enemy(i).y-15) AND _
                           (player.shot_y <= enemy(i).y+10) THEN   'actual hit detection
                           player.shot_fired = FALSE
                           enemy(i).state = st_EN_dead
                           enemy_remain -= 1
                           IF enemy_remain = 8 THEN enemy_speed = 2
                           IF enemy_remain = 4 THEN enemy_speed = 4
                           IF enemy_remain = 2 THEN enemy_speed = 6

                           score += 100 * ((2- enemy(i).kind\2)+1) + (enemy(i).y-20)\8
                           IF score>hiscore THEN hiscore = score

                           'WON the INVADER !!!
                           IF enemy_remain = 0 THEN game_state = flag_win


                           play_wav 3,3,255
                        END IF
                     END IF
                  END IF
               NEXT

            END IF

            MULTIPUT (,player.shot_x, player.shot_y, sprite_buffer(8), 3 , 3, 0 , 253, @CUSTOM_MONO_PUT, @colorkey)
            'PSET(player.shot_x, player.shot_y):DRAW"NU3NR3ND3NL3"


         END IF




         '---< E N E M Y >---
         enemy_anim_pattern_changed  = FALSE
         group_hit_wall = FALSE

         FOR j = 0 TO MAX_enemy
            IF enemy(j).used THEN
               SELECT CASE enemy(j).state
                  CASE st_EN_init  'not really needed
                     enemy_direction = 1
                     enemy(j).state = st_EN_move_sideway
                  CASE st_EN_move_sideway
                     'move side way
                     IF player.state = st_normal THEN

                        enemy(j).x += enemy_direction * enemy_speed

                        IF enemy(j).x >= 290 THEN group_hit_wall = TRUE
                        IF enemy(j).x <= 40  THEN group_hit_wall = TRUE



                        'add enemy fire routine here
                        IF RND(1)< .01 THEN    'enemy fire rate.... x_x


                           'search free shot slot
                           free_slot_found = -1
                           i = -1
                           DO
                              i += 1
                              IF enemy_shot(i).used = FALSE THEN free_slot_found = i
                           LOOP UNTIL free_slot_found >= 0 OR i>=MAX_enemy_shot

                           'initialize enemy shot
                           'done
                           IF free_slot_found > -1 THEN
                              enemy_shot(free_slot_found).used = TRUE
                              enemy_shot(free_slot_found).x = enemy(j).x AND &hfffe
                              enemy_shot(free_slot_found).y = ((enemy(j).y+1) - 2) AND &hfffe +1
                           END IF
                        END IF


                     END IF


                  CASE st_EN_move_down

                     enemy(j).Y += 8
                     enemy(j).state = st_EN_move_sideway


                     IF enemy(j).y >= 200 THEN
                        enemy(j).state = st_EN_dead
                        'set earth boom
                        player.state = st_dead  'player is dead
                        player.REST = 0   'earth goes boom!
                        player.delay = 0
                        play_wav 2,2,255

                     END IF








                  CASE st_EN_go_back

                     'not used
                  CASE st_EN_dead

                     ADD_PUFF(enemy(j).x  -1, (enemy(j).y+1) -2)

                     '-------------------
                     'get free puff slot
                     '                     free_slot_found = -1
                     '                     i = -1
                     '                     DO
                     '                        i += 1
                     '                        IF puff(i).used = FALSE THEN free_slot_found = i
                     '                     LOOP UNTIL free_slot_found >= 0 OR i>=MAX_puff
                     '                     IF free_slot_found>-1 THEN
                     '                        puff(free_slot_found).used = TRUE
                     '                        puff(free_slot_found).x = enemy(j).x  -1
                     '                        puff(free_slot_found).y = (enemy(j).y+1) -2
                     '                        puff(free_slot_found).style = 0
                     '                        puff(free_slot_found).delay = 10
                     '                        puff(free_slot_found).zoom = 1
                     '                     END IF
                     '
                     '---------------

                     enemy(j).used = FALSE

               END SELECT

               'enemy animation and display
               enemy(j).anim_pattern_delay += 1
               IF enemy(j).anim_pattern_delay >= 30-enemy_speed*6 THEN
                  enemy(j).anim_pattern_delay = 0
                  enemy(j).anim_pattern XOR= 1
                  enemy_anim_pattern_changed = TRUE
               END IF
               colorkey = enemy(j).armor



               MULTIPUT (,enemy(j).x, enemy(j).y, sprite_buffer(enemy(j).kind + enemy(j).anim_pattern), 4 , 4, 0 , 253, @CUSTOM_MONO_PUT, @colorkey)
               'PSET(enemy(j).x, enemy(j).y):DRAW"NU3NR3ND3NL3"
               'LINE(enemy(j).x-18, enemy(j).y-15)-(enemy(j).x+18, enemy(j).y+10),&hFF0000 ,b
            END IF
         NEXT

         'all enemy basic movement finished.
         'set all enemy to go down when any of them hit wall
         IF group_hit_wall THEN
            enemy_direction *= -1
            FOR j=0 TO MAX_enemy
               IF enemy(j).used THEN
                  enemy(j).state = st_EN_move_down
               END IF
            NEXT




         END IF


         'also, make enemy walk sound when they change animation pattern (whole group in sync)
         IF enemy_anim_pattern_changed  THEN
            enemy_walk_sound += 1
            IF enemy_walk_sound >3 THEN enemy_walk_sound = 0
            play_wav 4 + enemy_walk_sound,4,255



         END IF


         '---< E N E M Y  S H O T >---
         FOR i = 0 TO MAX_enemy_shot

            IF enemy_shot(i).used THEN
               'move bullet
               enemy_shot(i).y += 4

               enemy_shot(i).anim_pattern_delay += 1
               IF enemy_shot(i).anim_pattern_delay >0 THEN 'no animation delay
                  enemy_shot(i).anim_pattern_delay = 0
                  enemy_shot(i).anim_pattern  += 1
                  IF enemy_shot(i).anim_pattern >= 3 THEN  enemy_shot(i).anim_pattern  = 0
               END IF


               'check with tank
               'then boom!
               IF enemy_shot(i).y>= 240 THEN
                  enemy_shot(i).used = FALSE
               ELSE
                  'check hit
                  IF (enemy_shot(i).x >= player.x-20) AND _
                     (enemy_shot(i).x <= player.x+20) AND _
                     (enemy_shot(i).y >= player.y-15) AND _
                     (enemy_shot(i).y <= player.y+10) THEN   'actual hit detection
                     enemy_shot(i).used = FALSE

                     player.state = st_dead  'player is dead
                     player.delay = 0 'decrease REST later at the end of dead-state routine


                     play_wav 2,2,255
                  END IF


                  colorkey = &hc0c0c0
                  MULTIPUT (,enemy_shot(i).x, enemy_shot(i).y, sprite_buffer(11-enemy_shot(i).anim_pattern), 2 , 2, 0 , 253, @CUSTOM_MONO_PUT, @colorkey)
                  'PSET(enemy_shot(i).x, enemy_shot(i).y):DRAW"NU3NR3ND3NL3"

               END IF



            END IF




         NEXT




         'add shield calculation somewhere here..... if have time
         colorkey = &HFFFFFF
         'MULTIPUT (,160, 120+30, sprite_buffer(20), 10 , 4, 0 , 253, @CUSTOM_MONO_PUT, @colorkey)



         DRAW_PUFF()

         '         FOR i=0 TO MAX_puff
         '            IF puff(i).used THEN  'do some puff
         '               puff(i).zoom += .4
         '               puff(i).delay -= 1
         '               IF puff(i).delay <1 THEN puff(i).used = FALSE
         '
         '               IF puff(0).style = 0 THEN
         '                  colorkey = &hffffff
         '                  MULTIPUT (,puff(i).x , puff(i).y , sprite_buffer(17), puff(i).zoom , puff(i).zoom, 0 , 253, @CUSTOM_MONO_PUT, @colorkey)'
         '
         '               ELSE
         '                  PUT (puff(i).x, puff(i).y), sprite_buffer(18+(puff(i).delay\4)MOD 2), trans''
         '
         '
         '
         '               END IF
         '            END IF
         '         NEXT



         'score
         IF score>hiscore THEN hiscore = score
         TEXTDRAW 8,3, "SCORE  " & zerofill( score,8) & "     HI SCORE  " & zerofill( hiscore,8), 0


         'diplay remaining tank
         IF player.rest < 5 THEN
            FOR i=1 TO player.rest
               TEXTDRAW i*16,29*8-6, CHR(22,23), &hFFFF00, FALSE
            NEXT
         ELSE
            TEXTDRAW 1*16,29*8-6, CHR(22,23), &hFFFF00, FALSE

            TEXTDRAW 32,29*8-6, " x " & zerofill( player.rest,2), 0
         END IF




         'display credit
         TEXTDRAW 29*8,28*8, "credit " & zerofill( credit,2), 0

         LINE(0,240)-(399,299),0,bf 'border for 400x300 mode... if used...
         LINE(320,0)-(399,239),0,bf


         SCREENCOPY
         SWAP work_page, vis_page

         SLEEP 30, 1


         'set result flag when... win/gameover/quit

         IF result = flag_quit THEN ASK_QUIT(result) 'ask quit if esc was pressed


      LOOP UNTIL result <> flag_nothing  'game ended with some result

      WHILE INKEY <> "": WEND
      ' /////////////// game end //////////////////////

      SCREENSET 0,0

      IF score = hiscore THEN SAVE_HISCORE(hiscore)

      IF result = flag_win THEN CUTSCENE 0


      IF result = flag_gameover THEN

         TEXTDRAW 88,90, "G A M E   O V E R", 0
         SLEEP 1000,1

         ASK_CONTINUE(game_continue)

         'loop exit condition : no continue/quit invader/win invader

      END IF


   LOOP WHILE game_continue


END SUB











SUB GAME_CAVEDOWN(BYREF result AS INTEGER)

   DIM AS INTEGER DEBUGX=100,debugy=100

   TYPE player_type 'make it local for now
      x AS INTEGER
      y AS INTEGER
      HP AS INTEGER
      grid_x AS INTEGER
      grid_y AS INTEGER
      grid_x_offset AS INTEGER
      grid_y_offset AS INTEGER
      ground_x AS INTEGER
      control AS INTEGER
      speed AS INTEGER
      state AS INTEGER
      anim_pattern AS INTEGER
      old_anim_pattern AS INTEGER
      delay AS INTEGER 'all purpose...whatever....
      blink AS INTEGER
      blink_counter AS INTEGER
      is_hit AS INTEGER
      is_hit_counter AS INTEGER
   END TYPE

   TYPE enemy_type 'make it local for now
      used AS INTEGER
      x AS INTEGER
      y AS INTEGER
      grid_x AS INTEGER
      grid_y AS INTEGER
      grid_x_offset AS INTEGER
      grid_y_offset AS INTEGER
      ground_x AS INTEGER
      direction AS INTEGER
      state AS INTEGER
      anim_pattern AS INTEGER
      old_anim_pattern AS INTEGER
      delay AS INTEGER 'all purpose...whatever....
      boing AS SINGLE
      boing_direction AS INTEGER
   END TYPE

   TYPE spike_type
      used          AS INTEGER
      x             AS INTEGER 'actual x in the cave
      y             AS INTEGER 'actual y in the cave
      grid_x        AS INTEGER 'for looking at the map array
      grid_y        AS INTEGER 'for looking at the map array
      grid_y_offset AS INTEGER 'for checking ground
   END TYPE



   ENUM player_state
   st_init
   st_walk_in
   st_move
   st_stomp
   st_fall
   st_dead
   END ENUM

   ENUM enemy_state
   st_EN_init
   st_EN_move
   st_en_fall
   st_EN_fly
   st_EN_land
   st_EN_nothing
   END ENUM


   CONST MAX_SPIKE = 16

   DIM AS player_type player
   DIM AS enemy_type skull, bat
   DIM AS spike_type spike(MAX_SPIKE)
   'DIM AS puff_type puff(MAX_PUFF)

   DIM AS INTEGER i,j, free_slot_found' , landed , floor_bonus
   DIM AS INTEGER game_continue = FALSE, scroll_y, colorkey, btn_hold, shake, gameover_timer

   'cavedown init for new game

   DO ' new game or continue
      game_continue = FALSE

      'cutscene - mad commander
      'CUTSCENE 0
      'DEMO()

      MAKE_CAVE_MAP()  'new maze
      player.HP = 5
      player.x = 48  '-32+180
      player.y = 3*32+20

      player.grid_x = ABS(player.x \ 16)
      player.grid_y = (player.y-2-18) \ 32
      player.grid_X_offset = (player.x+8) MOD 16

      scroll_y = 0
      player.state = st_init
      player.control = FALSE
      player.anim_pattern = 0


      result = flag_nothing 'nothing happened yet

      FOR i=0 TO MAX_PUFF
         puff(i).used = FALSE
      NEXT
      gameover_timer = 0

      skull.used = FALSE
      skull.state = st_EN_nothing



      skull.used =FALSE
      skull.x =0
      skull.y=0
      skull.grid_x =0
      skull.grid_y =0
      skull.grid_x_offset =0
      skull.grid_y_offset =0
      skull.ground_x =0
      skull.direction =0
      skull.state =999
      skull.anim_pattern =0
      skull.old_anim_pattern =0
      skull.delay =0
      skull.boing =0
      skull.boing_direction =0





      bat.used = FALSE
      bat.state = st_EN_nothing

      DO

         SCREENSET work_page, vis_page



         IF MULTIKEY(SC_ESCAPE) THEN result = flag_quit

         IF gameover_timer >1 THEN
            gameover_timer-=1
            IF gameover_timer = 1 THEN result = flag_gameover
         END IF

         '---< S P A C E  K E Y checking >---

         'if space key then shake the screen!
         IF MULTIKEY(SC_SPACE) AND NOT btn_hold THEN
            IF player.state = st_move THEN 'only can stomp on ground
               play_wav 2, 2, 64*0 +127 'sound #2, channel 2, vol 64
               player.state = st_stomp
               shake = TRUE
               player.delay = 5 'shake screen for 5 frames
            END IF
         END IF
         btn_hold = MULTIKEY(SC_SPACE)



         '---< P L A Y E R  action >---
         SELECT CASE player.state

            CASE st_init 'init
               player.state = st_walk_in 'walk in
               player.blink = FALSE
               player.blink_counter = 0

            CASE st_walk_in 'walk in
               player.x += 2
               IF player.x >= 168 THEN
                  player.state = st_move 'action
                  player.control = TRUE  'user control enabled
               END IF

            CASE st_move
               'calculate all grid /////////// why this is here....
               player.grid_x = player.x \ 16
               'player.ground_x = (player.x+8) \ 16-1 'to check double ground tiles
               IF player.grid_x < 0 THEN player.grid_x = 0
               IF player.grid_x > 19 THEN player.grid_x = 19




               'check LEFT
               IF MULTIKEY(SC_LEFT) THEN
                  'if there is no wall then move to left
                  IF (cave_map(player.grid_x-1,player.grid_y)AND cave_wall)=0 OR player.grid_X_offset>0 THEN
                     player.x -= 2
                  END IF

               END IF

               'check RIGHT cursor key
               IF MULTIKEY(SC_RIGHT) THEN
                  'if there is no wall then move to right
                  IF (cave_map(player.grid_x+1,player.grid_y)AND cave_wall)=0 OR player.grid_X_offset<>0 THEN
                     player.x += 2
                  END IF
               END IF

               player.grid_X_offset = (player.x+8) MOD 16
               player.grid_y = (player.y-2-18) \ 32

               IF INKEY="z" THEN player.state = st_fall

               '              IF player.grid_X_offset = 0 THEN
               IF (player.grid_x_offset +4) MOD 16  <= 8 THEN

                  'check ground just below then fall
                  IF cave_map(player.grid_x,player.grid_y+1) = cave_space THEN
                     player.state = st_fall
                     '               floor_bonus = 0
                     'landed = FALSE
                  END IF

               ELSE
                  player.ground_x = (player.x+8) \ 16-1 'to check double ground tiles
                  player.grid_x = player.x \ 16
                  'player.ground_x = (player.x+8) \ 16-1 'to check double ground tiles
                  IF player.grid_x < 0 THEN player.grid_x = 0
                  IF player.grid_x > 19 THEN player.grid_x = 19

                  'if check both tile and if one of them is floor, stop!
                  IF (cave_map(player.ground_x,player.grid_y+1) AND cave_space) AND _
                     (cave_map(player.ground_x+1,player.grid_y+1) AND cave_space) THEN
                     player.state = st_fall
                     'floor_bonus = 0
                     'landed = FALSE
                  END IF

                  'LINE (player.grid_x*16,player.grid_y*32-scroll_y)-(player.grid_x*16+15, player.grid_y*32-scroll_y+31),&h0f0fFF,b

               END IF


               '''''''''''' if not 100% on the tile, then check 2 tiles.
            CASE st_stomp
               'a) shake screen for a bit
               'b) fire up spike missile, remove spike from floor tile
               'c) remove breakable floor if any
               '   check ground then set to falling if need to
               'if not falling, go back to move section

               ' if spike then, shoot spike


               IF cave_map(player.grid_x,player.grid_y+1) AND cave_spike THEN

                  cave_map(player.grid_x,player.grid_y+1) XOR = cave_spike
                  play_wav 1,3,127'32'*0+255
                  'dont forget to add spike particle @ somewhere...whatever plaace



                  '1. calculate map position of spike from grid-XY
                  '2. add spike object



                  '                  debugx = player.grid_x * 16 + 7 'use this to set spike
                  '                  debugy = (player.grid_y+1) * 32 + 9 'use this to set spike
                  '             or      (sx-7)\16   ((sy-9)\32 ) -1
                  '

                  debugx = player.grid_x * 16 + 7
                  debugy = (player.grid_y+1) * 32 + 9




                  '---< A D D  S P I K E  object >---
                  'search for empty spike object
                  free_slot_found = -1
                  i = -1
                  DO
                     i += 1
                     IF spike(i).used = FALSE THEN free_slot_found = i
                  LOOP UNTIL free_slot_found >= 0 OR i>=max_spike

                  'set spike x,y, so it can be used rightaway
                  IF free_slot_found > -1 THEN
                     spike(free_slot_found).used = TRUE
                     spike(free_slot_found).x = player.grid_x * 16 + 7+1
                     spike(free_slot_found).y = (player.grid_y+1) * 32 + 9
                     spike(free_slot_found).grid_x = (spike(free_slot_found).x-7)\16
                     spike(free_slot_found).grid_y = (spike(free_slot_found).y-9)\32
                     spike(free_slot_found).grid_y_offset = spike(free_slot_found).y MOD 32
                  END IF



               END IF

               player.delay -= 1
               IF player.delay = 0 THEN
                  player.state = st_move
                  shake = FALSE

                  'at the end of shake, break the floor if breakable.
                  'add floor particle
                  'remove floor flag

                  IF (player.grid_x_offset +4) MOD 16  <= 8 THEN
                     IF cave_map(player.grid_x,player.grid_y+1) AND cave_breakable THEN
                        cave_map(player.grid_x,player.grid_y+1) = cave_space

                        'get free puff slot

                        ADD_PUFF(player.grid_x * 16 -1, (player.grid_y+1) * 32 -2, 0)


                     END IF
                  END IF

               END IF


               'now, check ground...either 1 or 2 tile.
               'decide what tile to break.


               'IF player.grid_x_offset = 0 THEN
               '   IF cave_map(player.grid_x,player.grid_y+1) AND cave_floor THEN player.state = st_move: PLAY_WAV 7,3
               'ELSE
               '   player.ground_x = (player.x+8) \ 16-1 'to check double ground tiles
               '
               '  'if check both tile and if one of them is floor, stop!
               'IF (cave_map(player.ground_x,player.grid_y+1) AND cave_floor) OR _
               '   (cave_map(player.ground_x+1,player.grid_y+1) AND cave_floor) THEN player.state = st_move: PLAY_WAV 7,3
               '   'LINE (player.grid_x*16,player.grid_y*32-scroll_y)-(player.grid_x*16+15, player.grid_y*32-scroll_y+31),&h0f0fFF,b
               'END IF





            CASE st_fall
               'squid is falling
               player.y += 4
               scroll_y += 4

               'then calculate grid Y position
               player.grid_y = (player.y-2-18) \ 32
               player.grid_y_offset = (player.y + 12) MOD 32

               'if passing floor-height on each floor, check ground
               IF player.grid_y_offset = 0 THEN 'fall through center of hole
                  'decide check single or double tile
                  score += 10
                  IF score>hiscore THEN hiscore = score

                  IF cave_map(player.grid_x,player.grid_y+1) = cave_UFO THEN result = flag_win


                  'check x offset
                  IF (player.grid_x_offset +4) MOD 16  <= 8 THEN
                     'floor_bonus += 1 'add bonus for falling many floor


                     IF cave_map(player.grid_x,player.grid_y+1) AND cave_floor THEN
                        player.state = st_move
                        PLAY_WAV 7,3,255
                        'score += 10
                        'landed = TRUE
                     END IF
                  ELSE
                     player.ground_x = (player.x+8) \ 16-1 'to check double ground tiles

                     'if check both tile and if one of them is floor, stop!
                     IF (cave_map(player.ground_x,player.grid_y+1) AND cave_floor) OR _
                        (cave_map(player.ground_x+1,player.grid_y+1) AND cave_floor) THEN
                        player.state = st_move
                        PLAY_WAV 7,3,255
                        'score += 10
                        'landed = TRUE
                     END IF

                     'LINE (player.grid_x*16,player.grid_y*32-scroll_y)-(player.grid_x*16+15, player.grid_y*32-scroll_y+31),&h0f0fFF,b
                  END IF

                  'IF landed THEN
                  '   landed = false
               END IF

            CASE st_dead
               player.blink = TRUE 'just to be sure...
               player.y = player.y = 3*32+20
               shake = FALSE
               'DO nothing
               'maybe output some gameover message
               'then wait a bit
               'then set result to gameover
               'end game



         END SELECT

         'debug

         'draw map first
         DRAW_MINI_MAP scroll_y, shake


         'add player sprite
         'player animation pattern
         player.old_anim_pattern = player.anim_pattern
         player.anim_pattern = ABS((player.x+32)\8)  MOD 2


         'make funny alien walking sound
         IF player.old_anim_pattern <> player.anim_pattern THEN
            play_wav 4+player.anim_pattern,,200*0+255
         END IF



         '----------------------------------------------------------hit
         'if player is hit by enemy (can be dead)
         IF player.is_hit THEN
            player.is_hit = FALSE

            IF NOT player.blink THEN  'ignore if player is already hit and already blinking.
               player.HP -= 1

               'get free puff slot
               ADD_PUFF(player. x +2, player.y+1-2,2)


               IF player.HP >= 0 THEN
                  'check REST
                  'if enough left then blinking
                  player.blink = TRUE
                  player.blink_counter = 0


               ELSE
                  'or all dead... set system_message ready.
                  player.state = st_dead
                  gameover_timer = 50
               END IF

            END IF

         END IF



         ' blink    -----
         IF player.blink THEN
            player.blink_counter += 1

            IF player.blink_counter >= 50 THEN
               player.blink = FALSE
               player.blink_counter = 0
            END IF
         END IF

         'simply, if player is dead, remove player from screen
         IF player.state <> st_dead THEN
            IF (NOT player.blink) OR (player.blink AND (player.blink_counter \ 4) MOD 2 <> 0) THEN
               colorkey = &h00ffff 'IIF (player.blink, &hff0000, &h00FFFF)
               MULTIPUT (,player.x, player.y-scroll_Y-(player.state=st_stomp)*6, sprite_buffer(0+player.anim_pattern), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)
               'LINE (player.grid_x*16,player.grid_y*32-scroll_y)-(player.grid_x*16+15, player.grid_y*32-scroll_y+31),&h0f0fFF,b
               'LINE (player.ground_x*16,player.grid_y*32-scroll_y)-(player.ground_x*16+15, player.grid_y*32-scroll_y+31),&h0f0fFF,b
               'PSET(player.x, player.y-scroll_y):DRAW"NU3NR3ND3NL3"

            END IF
         END IF

         '---< S P I K E section >---
         FOR i=0 TO MAX_spike
            IF spike(i).used THEN  'spike in action!!!

               spike(i).y += 4 'fall down a bit

               'check if it hits ground...
               'but first get the its grid Y position and grid offset
               'then look at grid offset to determine if it hit ground.
               'then check map array with grid-y value
               'if map has ground flag, then remove spike. add ground-type puff there.

               'spike(free_slot_found).x = player.grid_x * 16 + 7
               'spike(free_slot_found).y = (player.grid_y+1) * 32 + 9
               spike(i).grid_x = (spike(i).x-7)\16
               spike(i).grid_y = (spike(i).y-1)\32
               spike(i).grid_y_offset = (spike(i).y-1) MOD 32





               'if hit ground
               IF spike(i).grid_y_offset = 28 AND  (cave_map(spike(i).grid_x,spike(i).grid_y+1) AND cave_floor) THEN
                  'if spike(i).grid_y_offset = 0 AND  (cave_map(spike(i).grid_x,spike(i).grid_y) AND cave_floor) THEN

                  spike(i).used = FALSE
                  'and add puff

                  'get free puff slot
                  ADD_PUFF(spike(i).x -10, spike(i).y -12+4,1)

               END IF


               IF bat.used THEN 'check hit with bat
                  'LINE (bat.x-10,bat.y-scroll_y-10)-(bat.x+9, bat.y-scroll_y+14),&h0f0fFF,b
                  IF (spike(i).x >= bat.x-10) AND _
                     (spike(i).x <= bat.x+ 9) AND _
                     (spike(i).y >= bat.y-14) AND _
                     (spike(i).y <= bat.y+14) THEN   'actual hit detection

                     'bat.used = FALSE
                     bat.state = st_EN_INIT
                     ADD_PUFF (bat.x, bat.y, 3)
                     score += 100
                     IF score>hiscore THEN hiscore = score
                     'score, make sound, remove bat...etc

                  END IF

               END IF

               IF skull.used THEN 'check hit with bat
                  IF (spike(i).x >= skull.x-13) AND _
                     (spike(i).x <= skull.x+12) AND _
                     (spike(i).y >= skull.y-14) AND _
                     (spike(i).y <= skull.y+14) THEN   'actual hit detection

                     skull.used = FALSE
                     skull.state = st_EN_nothing
                     ADD_PUFF (skull.x, skull.y, 3)
                     score += 1000
                     IF score>hiscore THEN hiscore = score
                     'score, make sound, remove bat...etc

                  END IF
                  'LINE (skull.x-13,skull.y-scroll_y-10)-(skull.x+12, skull.y-scroll_y+14),&h0f0fFF,b
               END IF






               'draw spike
               colorkey = &hff0000
               'MULTIPUT (,spike(i).x,spike(i).y-scroll_y, sprite_buffer(0), .8, 1, 180, 253, @CUSTOM_MONO_PUT, @colorkey)
               PUT (spike(i).x-5,spike(i).y-4-scroll_y), spike_buffer,custom, @CUSTOM_MONO_PUT, @colorkey
               'PSET(spike(i).x, spike(i).y-scroll_y):DRAW"NU3NR3ND3NL3"

               'MULTIPUT (,sx+i*16+7-1+2,sy+j*32+9-scroll_y, sprite_buffer(1-1), .8, 1, 180, 253, @CUSTOM_MONO_PUT, @colorkey)



               'IF puff(0).style = 0 THEN
               '   PUT (puff(i).x, puff(i).y-scroll_y), sprite_buffer(17), trans
               'ELSE
               '   PUT (puff(i).x, puff(i).y-scroll_y), sprite_buffer(18+(puff(i).delay\4)MOD 2), trans
               'END IF
            END IF
         NEXT



         '---< S P I D E R section >---

         IF NOT bat.used THEN
            IF player.grid_y > 4 THEN
               'bat initialize
               bat.used = TRUE
               bat.state = st_EN_init

            END IF
         END IF


         IF player.grid_y > bat.grid_y +3 THEN
            'bat initialize
            bat.used = TRUE
            bat.state = st_EN_init
         END IF

         'bat action
         IF bat.used THEN
            SELECT CASE bat.state
               CASE st_EN_init
                  bat.used = TRUE
                  bat.state = st_EN_move
                  bat.grid_x = player.grid_x *0 + 8
                  bat.grid_y = player.grid_y+1+3+1
                  bat.x = bat.grid_x * 16+0+7
                  bat.y = bat.grid_y * 32 + 18
                  bat.direction = ((player.x < bat.x) *2 +1) * 2
                  'bat.direction = -1

               CASE st_EN_move
                  'move TO that direction
                  'detect wall then bounce
                  bat.x += bat.direction

                  bat.grid_x = bat.x\16
                  bat.grid_y = bat.y\32
                  bat.grid_x_offset = bat.x MOD 16
                  bat.grid_y_offset = bat.y MOD 32

                  'if hit wall then bounce
                  SELECT CASE bat.direction
                     CASE -2 'when goes left, check left wall. if hit then bounce
                        IF (cave_map(bat.grid_x-1,bat.grid_y)AND cave_wall) AND bat.grid_X_offset<10 THEN
                           bat.direction *= -1
                        END IF
                     CASE 2 'when goes right, check right wall. if hit then bounce
                        IF (cave_map(bat.grid_x+1,bat.grid_y)AND cave_wall) AND bat.grid_X_offset>8 THEN
                           bat.direction *= -1
                        END IF
                  END SELECT

                  'now ground/ceiling check then fall or flyup
                  IF (bat.grid_x_offset+8  ) MOD 16  = 1 THEN

                     'check ground just below then fall
                     IF cave_map(bat.grid_x, bat.grid_y ) = cave_space THEN bat.state = st_EN_fall
                  END IF


               CASE st_EN_fall
                  bat.y -= 4

                  bat.grid_y = (bat.y-2-18+4) \ 32
                  bat.grid_y_offset = (bat.y + 14) MOD 32

                  IF bat.grid_y_offset = 0 THEN


                     '                     IF cave_map(bat.grid_x, bat.grid_y) = cave_space THEN bat.state = st_EN_fall

                     IF cave_map(bat.grid_x, bat.grid_y) AND cave_floor THEN
                        bat.state = st_EN_move: PLAY_WAV 7,3,255
                        bat.direction = ((player.x < bat.x) *2 +1) * 2

                     END IF


                  END IF


            END SELECT


            IF player.state <> st_dead AND (NOT player.blink) THEN
               IF (player.x >= bat.x-11) AND _
                  (player.x <= bat.x+10) AND _
                  (player.y >= bat.y-14) AND _
                  (player.y <= bat.y+14) THEN   'actual hit detection
                  player.is_hit = TRUE
                  bat.used = FALSE
                  bat.state = st_EN_nothing
                  play_wav 3,9
               END IF
            END IF

         END IF


         'bat display
         IF bat.used THEN
            bat.old_anim_pattern = bat.anim_pattern
            bat.anim_pattern = (ABS(bat.x\16) + (bat.y\8))  MOD 2

            colorkey = &h0000ff
            MULTIPUT (,bat.x,bat.y-scroll_y, sprite_buffer(2+bat.anim_pattern), 1, 2, 0, 253, @CUSTOM_MONO_PUT, @colorkey)
            'LINE (bat.grid_x*16,bat.grid_y*32-scroll_y)-(bat.grid_x*16+15, bat.grid_y*32-scroll_y+31),&h0f0fFF,b
            'LINE (bat.x-13,bat.y-scroll_y-14)-(bat.x+12, bat.y-scroll_y+14),&h0f0fFF,b

            'adjust bat box

            'LINE (bat.x-7,bat.y-scroll_y-8)-(bat.x+5, bat.y-scroll_y+10),&h0f0fFF,b
            'CIRCLE (100,100-scroll_y),50,&hFccFfc
            'PSET(bat.x, bat.y-scroll_y):DRAW"NU3NR3ND3NL3"

         END IF










         '---< O C T O P U S section >---

         IF NOT skull.used THEN

            IF player.grid_y > 8 THEN
               'skull initialize
               skull.used = TRUE
               skull.state = st_EN_init

               'ELSE
               '   skull.used = FALSE
               '   skull.state = st_EN_nothing
            END IF



         ELSE  'if used then
            'IF (player.grid_y > 8) THEN
            IF player.grid_y < skull.grid_y - 4 THEN  'if skull goes out of screen, reset
               'skull initialize
               'skull.used = false
               skull.state = st_EN_init
            END IF

            IF skull.grid_y < player.grid_y - 5 THEN 'final
               'skull initialize
               'skull.used = false
               skull.state = st_EN_init
            END IF
            ' END IF


            'END IF




            'ELSE
            'skull action
            'no movement yet
            'IF skull.used THEN
            SELECT CASE skull.state
               CASE st_EN_init
                  'skull.used = TRUE
                  skull.state = st_EN_move
                  skull.grid_x = player.grid_x *0 + 11
                  skull.grid_y = player.grid_y-4 'final
                  skull.x = skull.grid_x * 16+0+7
                  skull.y = skull.grid_y * 32 + 18
                  skull.direction = ((player.x < skull.x) *2 +1) * 2
                  'skull.direction = -1

               CASE st_EN_move
                  'move TO that direction
                  'detect wall then bounce
                  skull.x += skull.direction

                  skull.grid_x = skull.x\16
                  skull.grid_y = skull.y\32
                  skull.grid_x_offset = skull.x MOD 16
                  skull.grid_y_offset = skull.y MOD 32

                  'if hit wall then bounce
                  SELECT CASE skull.direction
                     CASE -2 'when goes left, check left wall. if hit then bounce
                        IF (cave_map(skull.grid_x-1,skull.grid_y)AND cave_wall) AND skull.grid_X_offset<10 THEN
                           skull.direction *= -1
                        END IF
                     CASE 2 'when goes right, check right wall. if hit then bounce
                        IF (cave_map(skull.grid_x+1,skull.grid_y)AND cave_wall) AND skull.grid_X_offset>8 THEN
                           skull.direction *= -1
                        END IF
                  END SELECT

                  'now ground/ceiling check then fall or flyup
                  IF (skull.grid_x_offset+8  ) MOD 16  = 1 THEN

                     'check ground just below then fall
                     IF cave_map(skull.grid_x, skull.grid_y +1) = cave_space THEN skull.state = st_EN_fall
                  END IF


               CASE st_EN_fall
                  skull.y += 4

                  skull.grid_y = (skull.y-2-18+4) \ 32
                  skull.grid_y_offset = (skull.y + 14) MOD 32

                  IF skull.grid_y_offset = 0 THEN


                     '                     IF cave_map(skull.grid_x, skull.grid_y) = cave_space THEN skull.state = st_EN_fall

                     IF cave_map(skull.grid_x, skull.grid_y+1) AND cave_floor THEN
                        skull.state = st_EN_land
                        'skull.state = st_EN_move

                        skull.delay = 0
                        skull.boing = 0

                        skull.boing_direction = 1
                        PLAY_WAV 7,3,255
                        skull.direction = ((player.x < skull.x) *2 +1) * 2

                     END IF


                  END IF

               CASE st_EN_land

                  skull.delay += 1
                  skull.boing += .2 * skull.boing_direction
                  IF skull.boing  >= .8 THEN skull.boing_direction *= -1
                  IF skull.boing  <= -.8 THEN skull.boing_direction *= -1

                  IF skull.delay >= 8 THEN        'original = 8
                     skull.delay = 0
                     skull.boing = 0
                     skull.state = st_EN_move
                  END IF







            END SELECT
            '            LINE (skull.x-13,skull.y-scroll_y-10)-(skull.x+12, skull.y-scroll_y+14),&h0f0fFF,b

            IF player.state <> st_dead AND (NOT player.blink) THEN
               IF (player.x >= skull.x-13) AND _
                  (player.x <= skull.x+12) AND _
                  (player.y >= skull.y-10) AND _
                  (player.y <= skull.y+14) THEN   'actual hit detection
                  player.is_hit = TRUE
                  skull.used = FALSE
                  skull.state = st_EN_nothing
                  play_wav 3,9
               END IF
            END IF
         END IF

         'enemy hit the player
         'kill enemy, score +, play some sound





         'skull display
         IF skull.used THEN

            skull.old_anim_pattern = skull.anim_pattern
            skull.anim_pattern = ABS(skull.x\16)  MOD 2

            colorkey = &h0000ff OR &hffffff
            MULTIPUT (,skull.x,skull.y-scroll_y+skull.boing*5+2, sprite_buffer(4+skull.anim_pattern), 1+skull.boing, 2-skull.boing, 0, 253, @CUSTOM_MONO_PUT, @colorkey)
            'LINE (skull.x-13,skull.y-scroll_y-10)-(skull.x+12, skull.y-scroll_y+14),&h0f0fFF,b


            'LINE (skull.grid_x*16,skull.grid_y*32-scroll_y)-(skull.grid_x*16+15, skull.grid_y*32-scroll_y+31),&h0f0fFF,b
            'CIRCLE (100,100-scroll_y),50,&hFccFfc
            'PSET(skull.x, skull.y-scroll_y):DRAW"NU3NR3ND3NL3"

         END IF



         DRAW_PUFF(scroll_y)

         #IFDEF DEBUG
         'debug
         #ENDIF

         TEXTDRAW 8,3, "SCORE  " & zerofill( score,8) & "     HI SCORE  " & zerofill( hiscore,8), 0


         TEXTDRAW 1*8,28*8, "HP"

         'FOR i=1 TO player.HP
         '   TEXTDRAW 2*8+i*10+2,28*8, CHR(1) & CHR(IIF(player.HP>8,43,32))
         'NEXT

         IF player.HP <= 8 THEN
            FOR i=1 TO player.HP
               TEXTDRAW 2*8+i*10+2,28*8, CHR(1)
            NEXT
         ELSE
            FOR i=1 TO 8
               TEXTDRAW 2*8+i*10+2,28*8, CHR(1)
            NEXT

            TEXTDRAW 2*8+80+12,28*8, "+"

         END IF
         'ELSE
         '            TEXTDRAW 3*8+4,28*8, CHR(1), 0
         '            TEXTDRAW 5*8+0,28*8, "x" & zerofill( player.HP,2), 0
         '         END if


         'credit
         TEXTDRAW 29*8,28*8, "credit " & zerofill( credit,2), 0

         LINE(0,240)-(399,299),0,bf 'border for 400x300 mode... if used...
         LINE(320,0)-(399,239),0,bf



         SCREENCOPY
         SWAP work_page, vis_page
         SLEEP 30, 1
         'screensync


         IF result = flag_quit THEN ASK_QUIT(result) 'ask quit if esc was pressed



      LOOP UNTIL result <> flag_nothing  'game ended with some result

      WHILE INKEY <> "": WEND

      SCREENSET 0,0

      IF score = hiscore THEN SAVE_HISCORE(hiscore)

      IF result = flag_gameover THEN
         TEXTDRAW 88,90, "G A M E   O V E R", 0
         SLEEP 1000,1
         ASK_CONTINUE(game_continue)
      END IF

      skull.used = FALSE
      skull.state = st_EN_nothing

      bat.used = FALSE
      bat.state = st_EN_nothing

   LOOP WHILE game_continue   'loop exit condition : gameover/quit invader/win invader


   IF  result = flag_win THEN
      'cutscene grendizer
      'DEMO

      CUTSCENE 1
      'cutscene land
      CUTSCENE 2
   END IF

END SUB

SUB CUTSCENE(BYVAL scene_number AS INTEGER = 0)
   DIM AS INTEGER end_of_scene,colorkey, counter = 0,rr,gg,bb,i
   DIM AS INTEGER x,y,z,xx,yy,zz 'multi purpose variable. may not needed
   DIM AS SINGLE sx,sy,sz 'some single variables

   DIM AS ANY PTR spr, BG_spr 'temp sprite, big sprite as background

   SCREENSET 0,0: CLS

   'be sure to use PAGE
   DO
      SCREENSET work_page, vis_page


      counter += 1
      END_of_scene = INKEY = CHR(27)

      CLS

      SELECT CASE scene_number
         CASE 0
            'draw BG
            IF counter = 1 THEN
               x = 200
               y = 180
            END IF
            IF counter >= 20 AND counter < 770 THEN
               LINE(0,0)-(319,150),&h7070c0,bf
               LINE(0,151)-(319,240),&h404040,bf

               colorkey = &hc0c020
               multiput (,205,92, sprite_buffer(4),5,5,0,254, @CUSTOM_MONO_PUT, @colorkey)

               colorkey = &hc0c0c0
               multiput (,200,140, sprite_buffer(20),4,3,0,254, @CUSTOM_MONO_PUT, @colorkey)

               colorkey = &hc02020
               multiput (,140,200, sprite_buffer(0),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(132,198)-(149,203),colorkey,bf

               colorkey = &hff7f00
               multiput (,140+1*50,200, sprite_buffer(3),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(178,198)-(199,203),colorkey,bf

               colorkey = &h00c000
               multiput (,140+2*50,200, sprite_buffer(5),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(228,198)-(253,203),colorkey,bf

               colorkey = &hc02020
               multiput (,140+3*50,200, sprite_buffer(1),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(282,198)-(299,203),colorkey,bf

               colorkey = &h00ffff
               multiput (,70,180, sprite_buffer(0),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE( 62,178)-( 79,183),colorkey,bf

            END IF
            IF counter >= 880 AND counter < 1350 THEN

               LINE(0,0)-(319,180),&h7070c0,bf
               LINE(0,181)-(319,240),&h404040,bf

               LINE(80,20)-(220,180),&h202020,bf
               LINE(80,20)-(220,180),&h404040,b
               LINE(150,20)-(150,180),&h404040,b

               LINE(110,180)-(110+60,240),0
               LINE(110+80,180)-(110+60+80,240),0
               '                                 top  secret
               '              TEXTDRAW 100, 40,"SECRET WEAPON"
               TEXTDRAW 100, 40," top    secret"
               TEXTDRAW 104, 60,"DATA    ROOM"
               TEXTDRAW 123, 95,"  o o", 0, FALSE

               colorkey = &h00ffff

               multiput (,x,y, sprite_buffer(0),10,10,0,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(x-21-1,y-5-1)-(x+22+1,y+5+1),&h00ffff,bf   'eye

            END IF

            IF counter > 50 AND counter <=130 THEN 'final
               colorkey = &hffffff
               multiput (,200,60, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70,10)-(300,54),&hffffff,bf
               TEXTDRAW (80,20,"SO EARTH FINALLY DEVELOPED")
               TEXTDRAW (80,40,"SUPER WEAPON, HeH !")
            END IF

            IF counter > 150 AND counter <=230 THEN 'final
               colorkey = &hffffff
               multiput (,200,60, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70,10)-(300,54),&hffffff,bf
               TEXTDRAW (80,20,"WE MUST DESTROY IT")
               TEXTDRAW (80,40,"NO MATTER WHAT !")
            END IF

            IF counter > 270 AND counter <=310 THEN
               colorkey = &hffffff
               multiput (,70,60+90, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70-60,10+90)-(300-60,54+90),&hffffff,bf
               TEXTDRAW (80-60,20+90,"COMMANDER,")
            END IF

            IF counter > 320 AND counter <=410 THEN
               colorkey = &hffffff
               multiput (,70,60+90, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70-60,10+90)-(300-60,54+90),&hffffff,bf
               TEXTDRAW (80-60,20+90,"MOST OF OUR MEN DIED...")
               TEXTDRAW (80-60,40+90,"WE CAN'T CONTINUE LIKE THIS")
            END IF


            IF counter > 420 AND counter <=470 THEN
               colorkey = &hffffff
               multiput (,200,60, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70,10)-(300,54),&hffffff,bf
               TEXTDRAW (80,20,"shut up you fool !")
            END IF
            IF counter > 480 AND counter <=560 THEN
               colorkey = &hffffff
               multiput (,200,60, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70,10)-(300,54),&hffffff,bf
               TEXTDRAW (80,20,"A LITTLE MORE AND IT WILL")
               TEXTDRAW (80,40,"BE OVER.")
            END IF
            IF counter > 590 AND counter <=680 THEN
               colorkey = &hffffff
               multiput (,200,60, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70,10)-(300,54),&hffffff,bf
               TEXTDRAW (80,20,"NOW, YOU LOWLY SCUM, GO")
               TEXTDRAW (80,40,"AND DO SOME KAMIKAZE ATTACK")
            END IF

            IF counter > 690 AND counter <=740 THEN
               colorkey = &hffffff
               multiput (,140,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               multiput (,140+50,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               multiput (,140+100,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               multiput (,140+150,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(110+10,10+100)-(300+10,54+100),&hffffff,bf
               TEXTDRAW (170+10,30+100,"Yes, SIR !")
            END IF


            'add "few hours later..."
            IF counter >800 AND counter <= 860 THEN
               TEXTDRAW (80-10,20+100,"a few hours later...")
            END IF

            IF counter >  930 AND counter <= 1010 THEN
               colorkey = &hffffff
               multiput (,200,60+70, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70-60,10+70)-(270,54+70),&hffffff,bf

               TEXTDRAW (80-60,20+70,"I CAN'T TAKE IT ANY MORE")
               TEXTDRAW (80-60,40+70,"I DON'T WANT TO DIE IN THIS WAR")
            END IF
            IF counter >  1030 AND counter <= 1090 THEN
               colorkey = &hffffff
               multiput (,200,60+70, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70-60,10+70)-(270,54+70),&hffffff,bf
               TEXTDRAW (80-60 ,20+70,"COMMANDER IS CRAZY")
            END IF
            IF counter >  1110 AND counter <= 1180 THEN
               colorkey = &hffffff
               multiput (,200,60+70, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70-60,10+70)-(270,54+70),&hffffff,bf
               TEXTDRAW (80-60  ,20+70,"I will escape to earth")
            END IF
            IF counter >  1200 AND counter <= 1300 THEN
               colorkey = &hffffff
               multiput (,200,60+70, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               LINE(70-60,10+70)-(270,54+70),&hffffff,bf
               TEXTDRAW (80-60  ,20+70,"before i go...")
               TEXTDRAW (80-60  ,40+70,"I will take something")

            END IF
            IF counter > 1300 AND counter <= 1400 THEN
               x-=1
               y-=1
            END IF
            IF (counter > 1400 AND counter <=1425+20) OR _
               (counter > 1450+20 AND counter <=1475+40) OR _
               (counter > 1500+40 AND counter <=1525+60) OR _
               (counter > 1550+60 AND counter <=1575+80)  THEN

               LINE(0,60)-(319,160),&hFF0000,bf
               TEXTDRAW (70-10,15+70,"    WARNING !  WARNING !  ")
               TEXTDRAW (70-10,40+70,"SOMEONE STOLE TOP SECRET !")
               TEXTDRAW (70-10,65+70,"   FIND THE TRAITOR ! !   ")
            END IF

            'alarm
            IF counter = 1400  OR counter = 1450+20 OR counter = 1500+40  OR counter = 1550+60 THEN
               play_wav 8,8,255
            END IF
            IF counter =1425+20 OR counter =1475+40 OR counter =1525+60 OR counter =1575+80 THEN
               play_wav 8,8,0
            END IF

            IF counter>=1660 THEN end_of_scene = TRUE


         CASE 1 'second cut scene '-------------------------------------------------------------------------
            'make BG because it uses huge multiput sprites.

            IF counter = 1 THEN
               BG_spr = IMAGECREATE(320+320,240)

               LINE BG_spr,(0,0)-(319+320,239), &h202020,bf

               '               LINE BG_spr,(0,0)-(110+60,2), &hff8000,bf
               '               LINE BG_spr,(150+60,0)-(319+60,2), &hff8000,bf
               '               LINE BG_spr,(0,215)-(319+60,239), &hff8000, bf

               colorkey = &hdddddd
               multiput (BG_spr,147+320+15,120, sprite_buffer(6),19,19,,254, @CUSTOM_MONO_PUT, @colorkey)

               LINE BG_spr,( 60+320+1    ,131   )-(260+320+1   ,152   ),&hdddddd, bf
               LINE BG_spr,(200+320+1    ,131   )-(280+320+1    ,152   ),0, bf
               LINE BG_spr,(200+320+1    ,152   )-(200+320+1 -84,152-84),0
               LINE BG_spr,(200+320+1 -84,152-84)-(220+320+1 -63,131-63),0
               LINE BG_spr,(220+320+1    ,131   )-(220+320+1 -63,131-63),0
               PAINT BG_spr,(200+320-84+20,152-84+10),0,0

               x = 132+320 'run run duke!
               y = -33 'fly fly grr.r....oops!
               sx = 2
               z = 0 - 320 'ufo position
               colorkey = &h00ffff
               're init squid
               spr = IMAGECREATE(10+1, 10)
               PUT spr, (1, 1), resource_graphic, (8, 0)-(8 + 7, 0 + 7), PSET
               PSET spr, (3,4), &hffffff
               PSET spr, (1,4), &hff00ff
               PSET spr, (1,5), &hff00ff

               'PSET spr, (6,4), &hffffff

               'PUT (10,10), spr, pset
            END IF

            PUT (z+0,0),bg_spr,PSET
            LINE  (0,0)-(110 ,2), &hff8000,bf
            LINE  (150 ,0)-(319 ,2), &hff8000,bf
            LINE  (0,215)-(319 ,239), &hff8000, bf

            IF counter > 1 AND counter <= 50 THEN
               y += 2
               ' multiput (,x,y, spr,sx,2,,254)
            END IF
            IF counter > 50 AND counter <= 89 THEN
               x += 2
               y += 2
               colorkey = &h00ffff
               'multiput (,x,y, spr,2,2,,254,@CUSTOM_MONO_PUT, @colorkey)
            END IF
            IF counter > 88 AND counter <= 98 THEN
               sx -= .2
               'multiput (,x,y, spr,sx,2,,254,@CUSTOM_MONO_PUT, @colorkey)
            END IF
            IF counter = 98 THEN
               'spr = IMAGECREATE(10+1, 10)
               PUT spr, (1, 1), resource_graphic, (8, 0)-(8 + 7, 0 + 7), PSET
               'PSET spr, (3,4), &hffffff:
               PSET spr, (6,4), &hffffff 'eye
               PSET spr, (8,4), &hff00ff 'making head
               PSET spr, (8,5), &hff00ff

            END IF
            IF counter > 98 AND counter <= 108 THEN
               sx += .2
               'multiput (,x,y, spr,sx,2,,254,@CUSTOM_MONO_PUT, @colorkey)
            END IF

            IF counter > 108 AND counter <= 128 THEN
               x += 2
               ' multiput (,x,y, spr, 2,2,,254,@CUSTOM_MONO_PUT, @colorkey)
            END IF
            IF counter = 128 THEN
               sx = 2
            END IF
            IF counter > 128 AND counter <= 138 THEN
               sx -= .2
               'multiput (,x,y, spr,sx,2,,254,@CUSTOM_MONO_PUT, @colorkey)
            END IF
            IF counter = 138 THEN
               'spr = IMAGECREATE(10+1, 10)
               PUT spr, (1, 1), resource_graphic, (8, 0)-(8 + 7, 0 + 7), PSET
               PSET spr, (3,4), &hffffff
               PSET spr, (1,4), &hff00ff
               PSET spr, (1,5), &hff00ff
               'PSET spr, (6,4), &hffffff
            END IF
            IF counter > 138 AND counter <= 148 THEN
               sx += .2
               'multiput (,x,y, spr,sx,2,,254,@CUSTOM_MONO_PUT, @colorkey)
            END IF
            IF counter > 148 AND counter <= 158 THEN
               x += 2
            END IF

            multiput (,x+z,y, spr,sx,2,,254,@CUSTOM_MONO_PUT, @colorkey)

            IF counter = 168 THEN play_wav 8,8,255

            IF counter >168 THEN
               z+= 2
            END IF
            IF counter >178 THEN
               z+= 2
            END IF
            IF counter >188 THEN
               z+= 4
            END IF
            IF counter >198 THEN
               z+= 8
            END IF

            'GETMOUSE x,y
            'multiput (,x,y, spr,2,2,,)

            IF counter>=210 THEN
               play_wav 8,8,0
               IMAGEDESTROY (spr)
               IMAGEDESTROY (bg_spr)
               end_of_scene = TRUE
            END IF

         CASE 2 '---------------------------------------------------------------------------------------


            IF COUNTER >0 AND COUNTER < 320 THEN
               'make some background
               RR = 0
               GG = 21
               BB = 46

               FOR i = 0 TO 23
                  LINE(0,i*10)-(319,i*10+9), RGB(rr,gg,bb), bf
                  rr += 2
                  gg +=7
                  BB +=6
               NEXT
               colorkey = &hffff00
               MULTIPUT (,48, 225, sprite_buffer(7), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)
            END IF

            IF counter = 1 THEN
               x=-32
               y=90
            END IF

            '-----------------
            '  draw tank

            IF counter > 1 AND counter <= 40 THEN
               x+= 4
               colorkey = &hffff00

               MULTIPUT (,x, y, sprite_buffer(6), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)

            END if
            IF counter > 40 AND counter <= 60 THEN
               y+= 4
               colorkey = &hffff00

               MULTIPUT (,x, y, sprite_buffer(6), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)

            END if

            IF counter >60 AND counter <270 THEN MULTIPUT (,x, y, sprite_buffer(6), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)

            IF counter > 60 AND counter <= 150 THEN
               LINE(10,90)-(250,155),&hffffff,bf
               colorkey = &hffffff
               multiput (,x+11,y-10, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               TEXTDRAW (20,y-70,"DON'T SHOOT")
               TEXTDRAW (20,y-50,"I HAVE A SECRET WEAPON DATA")
               TEXTDRAW (20,y-30,"I'M ON YOUR SIDE")
            end if

            IF counter > 170 AND counter <= 260 THEN
               LINE(10,90)-(250,155),&hffffff,bf
               colorkey = &hffffff
               multiput (,x+11,y-10, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
               TEXTDRAW (20,y-70,"OK,")
               TEXTDRAW (20,y-50,"I WILL WORK ON ")
               TEXTDRAW (20,y-30,"SECRET WEAPON")
            end if

            IF counter > 270 AND counter <= 320 THEN
               y+= 4
               colorkey = &hffff00
               MULTIPUT (,x, y, sprite_buffer(6), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)

            END if





            'add "few hours later..."
            IF counter >350 AND counter <= 410 THEN
               TEXTDRAW (80-10,20+100,"a few hours later...")
            END IF

            IF COUNTER  > 450 THEN end_of_scene = TRUE

         CASE 3 '---------------------------------------------------------------------------------------


               RR = 30
               GG = 200-20
               BB = 255-20

               FOR i = 0 TO 23
                  LINE(0,i*10)-(319,i*10+9), RGB(rr,gg,bb), bf
                  'rr += 2
                  gg -=7
                  'BB +=6
               NEXT
               colorkey = &h00ffFF
               MULTIPUT (,230, 180, sprite_buffer(0), 8 , 8 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)
               LINE(204,174)-(257,187),COLORKEY,BF

               colorkey = &hFFFF00
               MULTIPUT (, 80, 170, sprite_buffer(7), 8 , 10 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)


               TEXTDRAW (50,20+10,"crazy alien COMMANDER is dead")
               TEXTDRAW (50,40+10,"     war is finally over     " )
               TEXTDRAW (50,60+10,"        peace forever        " )
               TEXTDRAW (50,90+20,"           THE END           " )



            IF COUNTER  > 250 THEN end_of_scene = TRUE




      END SELECT



      LINE(0,240)-(399,299),0,bf 'border for 400x300 mode... if used...
      LINE(320,0)-(399,239),0,bf


      SCREENCOPY
      SWAP work_page, vis_page


      SLEEP 30,1



   LOOP UNTIL end_of_scene
   WHILE MULTIKEY(SC_ESCAPE):SLEEP 1: WEND
   WHILE INKEY <> "": WEND

   SCREENSET 0,0

END SUB




'add_puff (BYVAL x AS INTEGER, BYVAL y AS INTEGER,


SUB DRAW_PUFF(BYVAL scroll_y AS INTEGER = 0)
   DIM AS INTEGER i, colorkey

   '---< P U F F >---
   FOR i=0 TO MAX_PUFF
      IF puff(i).used THEN  'do some puff

         puff(i).delay -= 1
         IF puff(i).delay <1 THEN puff(i).used = FALSE

         SELECT CASE puff(i).style
            CASE 0 'normal puff
               PUT (puff(i).x, puff(i).y-scroll_y), sprite_buffer(17), trans
            CASE 1 'ground puff
               PUT (puff(i).x, puff(i).y-scroll_y), sprite_buffer(18+(puff(i).delay\2)MOD 2), trans
            CASE 2 'zoom normal puff
               puff(i).zoom += .6
               multiput (,puff(i).x, puff(i).y-scroll_y, sprite_buffer(17), puff(i).zoom,puff(i).zoom,0,254)
            CASE 3 'zoom normal puff different duration
               puff(i).zoom += .6
               multiput (,puff(i).x, puff(i).y-scroll_y, sprite_buffer(17), puff(i).zoom,puff(i).zoom,0,254)
            CASE 4 'zoom normal puff different duration . different color
               puff(i).zoom += 1
               colorkey = INT(RND(1)*&hffffff)
               colorkey = &hffffff

               multiput (,puff(i).x, puff(i).y-scroll_y, sprite_buffer(17), puff(i).zoom,puff(i).zoom,0,254, @custom_mono_put, @colorkey)
            CASE 255 'zoom normal puff for invader
               puff(i).zoom += .4
               multiput (,puff(i).x, puff(i).y-scroll_y, sprite_buffer(17), puff(i).zoom,puff(i).zoom,0,254)

         END SELECT
      END IF
   NEXT

END SUB

SUB ADD_PUFF(BYVAL x AS INTEGER, BYVAL y AS INTEGER, BYVAL style AS INTEGER = 255)
   DIM AS INTEGER i, free_slot_found

   'get free puff slot
   free_slot_found = -1
   i = -1
   DO
      i += 1
      IF puff(i).used = FALSE THEN free_slot_found = i
   LOOP UNTIL free_slot_found >= 0 OR i>=MAX_PUFF


   IF free_slot_found>-1 THEN


      puff(free_slot_found).used = TRUE
      puff(free_slot_found).x = x
      puff(free_slot_found).y = y
      puff(free_slot_found).style = style
      SELECT CASE style
         CASE 0 'normal puff, no zoom, in cave, breakable floor
            puff(free_slot_found).delay = 10
         CASE 1 'ground puff, used in cave
            puff(free_slot_found).delay = 4
         CASE 2 'zoom normal puff, used in both
            puff(free_slot_found).delay = 5
            puff(free_slot_found).zoom = 1
         CASE 3 'zoom normal puff, used in both
            puff(free_slot_found).delay = 3
            puff(free_slot_found).zoom = 1
         CASE 4 'zoom normal puff, used in both
            puff(free_slot_found).delay = 6
            puff(free_slot_found).zoom = 1
         CASE 255 'zoom normal puff, used in invader
            puff(free_slot_found).delay = 10
            puff(free_slot_found).zoom = 1
      END SELECT
   END IF



END SUB

SUB DEMO()

   DIM AS INTEGER colorkey,rr,gg,bb,i,j,x,y,z,sx,sy,sz

   SCREENSET 0,0:CLS
   CLS



   'make some background
   RR = 0
   GG = 21
   BB = 46
   FOR i = 0 TO 23
      LINE(0,i*10)-(319,i*10+9), RGB(rr,gg,bb), bf
      rr+= 2
      gg+=7
      BB+=6
   NEXT

   sleep

   'draw tank
   colorkey = &hffff00
   MULTIPUT (,48, 210, sprite_buffer(7), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)

   SLEEP


   '   '  scene 1
   '   LINE(0,0)-(319,150),&h7070c0,bf
   '   LINE(0,151)-(319,240),&h404040,bf
   '
   '
   '   'script - so earth finally developed super weapon, huh !
   '   colorkey = &hffffff
   '   multiput (,200,60, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(70,10)-(300,54),&hffffff,bf
   '   TEXTDRAW (80,20,"SO EARTH FINALLY DEVELOPED")
   '   TEXTDRAW (80,40,"SUPER WEAPON,HUH !")
   '
   '   SLEEP
   '   'script - we must destroy it no matter what!
   '   LINE(70,10)-(300,54),&hffffff,bf
   '   TEXTDRAW (80,20,"WE MUST DESTROY IT")
   '   TEXTDRAW (80,40,"NO MATTER WHAT !")
   '   SLEEP
   '
   '   colorkey = &hffffff
   '   multiput (,70,60+90, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(70-60,10+90)-(300-60,54+90),&hffffff,bf
   '   '240,150
   '
   '   TEXTDRAW (80-60,20+90,"COMMANDER,")
   '   SLEEP
   '   LINE(70-60,10+90)-(300-60,54+90),&hffffff,bf
   '
   '   TEXTDRAW (80-60,20+90,"MOST OF OUR MEN DIED..")
   '   TEXTDRAW (80-60,40+90,"WE CAN'T CONTINUE LIKE THIS")
   '
   '   SLEEP
   '   LINE(70,10)-(300,54),&hffffff,bf
   '   TEXTDRAW (80,20,"shut up you fool !")
   '
   '   SLEEP
   '   LINE(70,10)-(300,54),&hffffff,bf
   '   TEXTDRAW (80,20,"A LITTLE MORE AND IT WILL")
   '   TEXTDRAW (80,40,"BE OVER.")
   '
   '   SLEEP
   '   LINE(70,10)-(300,54),&hffffff,bf
   '   TEXTDRAW (80,20,"NOW, YOU LOWLY SCUM, GO")
   '   TEXTDRAW (80,40,"AND DO SOME KAMIKAZE ATTACK")
   '
   '   SLEEP
   '
   '
   '   colorkey = &hffffff
   '   multiput (,140,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
   '   multiput (,140+50,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
   '   multiput (,140+100,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
   '   multiput (,140+150,60+100, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(110+10,10+100)-(300+10,54+100),&hffffff,bf
   '
   '   TEXTDRAW (170+10,30+100,"Yes, SIR !")
   '
   '   SLEEP
   '
   '
   '
   '
   '
   '
   '
   '
   '
   '
   '
   '
   '
   '
   '   'scene 2
   '   LINE(0,0)-(319,180),&h7070c0,bf
   '   LINE(0,181)-(319,240),&h404040,bf
   '
   '   LINE(80,20)-(220,180),&h202020,bf
   '   LINE(80,20)-(220,180),&h404040,b
   '   LINE(150,20)-(150,180),&h404040,b
   '
   '   LINE(110,180)-(110+60,240),0
   '   LINE(110+80,180)-(110+60+80,240),0
   '
   '   TEXTDRAW 100, 40,"SECRET WEAPON"
   '   TEXTDRAW 100,60,"  DATA ROOM  "
   '   TEXTDRAW 123,95,"  o o", 0, FALSE
   '
   '   colorkey = &h00ffff
   '   multiput (,110+100-10,170+10, sprite_buffer(0),10,10,0,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(79+100,175)-(122+100,186),&h00ffff,bf   'eye
   '
   '   SLEEP
   '
   '
   '   colorkey = &hffffff
   '   multiput (,200,60+70, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(70-60,10+70)-(270,54+70),&hffffff,bf
   '
   '   TEXTDRAW (80-60,20+70,"I CAN'T TAKE IT ANY MORE")
   '   TEXTDRAW (80-60,40+70,"I DON'T WANT TO DIE IN THIS WAR")
   '
   '
   '   SLEEP
   '
   '   LINE(70-60,10+70)-(270,54+70),&hffffff,bf
   '
   '   TEXTDRAW (80-60 ,20+70,"COMMANDER IS CRAZY")
   '   TEXTDRAW (80-60  ,40+70,"I'M GOING TO EARTH")
   '
   '
   '
   '
   '
   '   'scene 3
   '
   '   LINE(0,0)-(319,150),&h7070c0,bf
   '   LINE(0,151)-(319,240),&h404040,bf
   '
   '   colorkey = &hc0c020
   '   multiput (,205,92, sprite_buffer(4),5,5,0,254, @CUSTOM_MONO_PUT, @colorkey)
   '
   '   colorkey = &hc0c0c0
   '   multiput (,200,140, sprite_buffer(20),4,3,0,254, @CUSTOM_MONO_PUT, @colorkey)
   '
   '   colorkey = &hc02020
   '   multiput (,140,200, sprite_buffer(0),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(132,198)-(149,203),colorkey,bf
   '
   '   colorkey = &hff7f00
   '   multiput (,140+1*50,200, sprite_buffer(3),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(178,198)-(199,203),colorkey,bf
   '
   '   colorkey = &h00c000
   '   multiput (,140+2*50,200, sprite_buffer(5),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(228,198)-(253,203),colorkey,bf
   '
   '   colorkey = &hc02020
   '   multiput (,140+3*50,200, sprite_buffer(1),4,4,0,254, @CUSTOM_MONO_PUT, @colorkey)
   '   LINE(282,198)-(299,203),colorkey,bf
   '
   '



   SLEEP '5000
END SUB

SUB ASK_QUIT(BYREF result AS INTEGER)

   #IFNDEF quick_quit
   DIM AS STRING user_input

   'check credit then exit whatever

   SCREENSET 0,0

   'TEXTDRAW 29*8,28*8, "credit " & zerofill( credit,2), 0    'no need

   '   IF credit>0 THEN
   WHILE MULTIKEY(SC_ESCAPE):SLEEP 1:WEND
   TEXTDRAW 28,110, " EXIT to Title screen? (Y/N) ", 0

   WHILE INKEY <> "": WEND

   DO

      user_input = UCASE(INKEY)

      SLEEP 1,1
   LOOP UNTIL INSTR("YN"+CHR(27), user_input)

   result = user_input = "Y"

   WHILE MULTIKEY(SC_ESCAPE):SLEEP 1:WEND

   WHILE INKEY <> "": WEND

   IF result THEN
      play_wav 2,2,255
   END IF
   #ENDIF

END SUB

SUB GAME_PHOENIX(BYREF result AS INTEGER)

   DIM AS INTEGER DEBUGX=100, debugy=100
   DIM AS INTEGER rr,gg,bb

   TYPE player_type 'make it local for now
      x AS INTEGER
      y AS INTEGER
      HP AS INTEGER
      control AS INTEGER
      speed AS INTEGER
      state AS INTEGER
      anim_pattern AS INTEGER
      old_anim_pattern AS INTEGER
      delay AS INTEGER 'all purpose...whatever....
      blink AS INTEGER
      is_hit AS INTEGER

      shot_fired AS INTEGER 'single shot
      shot_x AS INTEGER
      shot_y AS INTEGER
   END TYPE

   TYPE boss_type
      used AS INTEGER
      direction AS INTEGER
      x AS INTEGER
      y AS INTEGER
      wave_counter AS INTEGER
      dy AS INTEGER
      dy_speed AS INTEGER
      state AS INTEGER
      action_counter AS INTEGER
      hp AS INTEGER
      windows(3) AS INTEGER
      windows_waiting(3) AS INTEGER
   END TYPE

   TYPE enemy_type
      used AS INTEGER
      kind AS INTEGER 'alien race
      x AS INTEGER
      y AS INTEGER
      state AS INTEGER
      action_counter AS INTEGER
      hp AS INTEGER
   END TYPE


   TYPE kamikaze_type
      used          AS INTEGER
      x             AS INTEGER 'actual x in the cave
      y             AS INTEGER 'actual y in the cave
      counter       AS INTEGER
      state AS integer
   END TYPE



   ENUM player_state
   st_init
   st_move_in
   st_move
   st_dead
   END ENUM

   ENUM boss_stste
   st_boss_ZZZ 'not used
   st_boss_init
   st_boss_move_in
   st_boss_talk
   st_boss_move
   st_boss_kamikaze ' not used
   st_boss_spike    ' not used
   st_boss_whatever 'add more
   st_follow_UFO
   st_fall
   st_ZZZ
   END ENUM

   ENUM enemy_state
   st_enemy_init
   st_enemy_move
   st_enemy_whatever 'add more
   END ENUM


   CONST MAX_kamikaze = 64  'banzai~!
   CONST max_ENEMY = 8
   CONST max_shot = 16

   DIM AS player_type player
   DIM AS boss_type boss
   DIM AS enemy_type enemy(MAX_enemy)
   'DIM AS shot_type shot(MAX_shot) 'used by enemy
   DIM AS kamikaze_type kamikaze(MAX_kamikaze), octopus, squid

   DIM AS INTEGER i,j, free_slot_found, warning
   DIM AS INTEGER game_continue = FALSE, colorkey, btn_hold, gameover_timer, win_timer, GAME_TIMER

   DIM AS INTEGER windows_offset(3) = {-38, -12, 13, 39}, super_weapon

   DIM AS ANY PTR boss_UFO, boss_frame 'boss sprite

   DO ' new game or continue
      game_continue = FALSE

      'don't call demo from here. add at the end of previous game
      'cutscene - mad commander
      'CUTSCENE 3
      'DEMO()



      player.state = st_init
      boss.state = st_boss_ZZZ

      boss.y=-40


      result = flag_nothing 'nothing happened yet
      gameover_timer = 0
      win_timer = 0
      game_timer = 0
      
      super_weapon = false
      
      
      
      warning = 230

      FOR i=0 TO MAX_PUFF
         puff(i).used = FALSE
      NEXT

      FOR i=0 TO MAX_kamikaze
         kamikaze(i).used = FALSE
      NEXT



      'make boss UFO
      boss_UFO = IMAGECREATE (136,62)
      boss_frame = IMAGECREATE (136+1,62+2)
      colorkey = &hdedede
      multiput( boss_UFO  , 60,22, sprite_buffer(6), 8 , 8 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)

      PUT BOSS_FRAME, (1-1,1-1), boss_UFO,trans
      PUT BOSS_FRAME, (1-1,1+0), boss_UFO,trans
      PUT BOSS_FRAME, (1-1,1+1), boss_UFO,trans
      PUT BOSS_FRAME, (1+0,1-1), boss_UFO,trans
      PUT BOSS_FRAME, (1+0,1+1), boss_UFO,trans
      PUT BOSS_FRAME, (1+1,1-1), boss_UFO,trans
      PUT BOSS_FRAME, (1+1,1+0), boss_UFO,trans
      PUT BOSS_FRAME, (1+1,1+1), boss_UFO,trans
      PUT BOSS_FRAME, (1+0,1+0), BOSS_UFO,CUSTOM, @CUSTOM_MASK_PUT

      colorkey = &hdddddd
      multiput( boss_UFO  , 60,22, sprite_buffer(6), 8 , 8 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)


      'multiput( boss_frame, 60,22, sprite_buffer(6), 8 , 8 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)

      'colorkey = &hdddddd
      'multiput( boss_UFO  , 64,31, boss_frame      , 1 , .99 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)


      '      PUT(0,0), boss_ufo,PSET




      DO
game_timer += 1
         SCREENSET work_page, vis_page



         'make some background
         RR = 0
         GG = 21
         BB = 46
         FOR i = 0 TO 23
            LINE(0,i*10)-(319,i*10+9), RGB(rr,gg,bb), bf
            rr+= 2
            gg+=7
            BB+=6
         NEXT

         'testing
'
' IF game_timer > 1000 AND game_timer <= 1010 THEN  
' 
'    squid.x = player.x+2
'    squid.y = 230
'            colorkey = &h008ff
'            PUT (squid.x,squid.y), sprite_buffer(0), custom, @CUSTOM_MONO_PUT, @colorkey
' END IF 
' 
' IF game_timer >1010 AND game_timer<= 2020 THEN
'    squid.x = player.x+2
'    squid.y -= 1
'            colorkey = &h008ff
'            PUT (squid.x,squid.y), sprite_buffer(0), custom, @CUSTOM_MONO_PUT, @colorkey
' 
' '           colorkey = &h008ff
' '           PUT (player.x,player.y), sprite_buffer(0), custom, @CUSTOM_MONO_PUT, @colorkey
' '           LINE(player.x,player.y-40)-(player.x+86,player.y-16),&hffffff,bf
' '           colorkey = &hffffff
' '           multiput (,player.x+11 ,player.y-10, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
' '           TEXTDRAW (player.x+3,player.y-30,"it is done")
' END if 

 IF game_timer >1060 AND game_timer<= 1150 THEN

            LINE(player.x,player.y-40)-(player.x+86,player.y-16),&hffffff,bf
            colorkey = &hffffff
            multiput (,player.x+11 ,player.y-10, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
            TEXTDRAW (player.x+3,player.y-30,"it is done")
 END IF
 












         IF MULTIKEY(SC_ESCAPE) THEN result = flag_quit

         IF gameover_timer >1 THEN 'when all dead, set this variable to something like 100
            gameover_timer-=1
            IF gameover_timer = 1 THEN result = flag_gameover
         END IF

         IF win_timer >1 THEN 'when win, wait few second for octopus' death
            win_timer-=1
            IF win_timer = 1 THEN result = flag_win
         END IF





         'BOSS action -----------------------------------------------------------------------------------
         SELECT CASE boss.state
            CASE st_boss_ZZZ
            CASE st_boss_init
               boss.used = TRUE
               boss.direction = 1
               boss.x = 160
               boss.y = -40
               boss.dy = 4-1
               boss.state = st_boss_move_in
               boss.action_counter = 0
               boss.hp = 100


               octopus.state = st_follow_UFO

            CASE st_boss_move_in
               boss.y+=1
               IF boss.y > 60 THEN boss.state = st_boss_talk



            CASE st_boss_talk


               boss.state = st_boss_move 'enough talk, have at you!

            CASE st_boss_move
               boss.x += boss.direction * 2

               IF boss.x >= 319 - 40 THEN boss.direction *= -1   'bounce off
               IF boss.x <= 0 +40 THEN boss.direction *= -1 ' bounce off

               boss.y += boss.dy

               boss.dy_speed XOR= 1
               IF boss.y > 60 THEN
                  IF boss.dy_speed THEN boss.dy -= 1
               ELSE
                  IF boss.dy_speed THEN boss.dy += 1
               END IF






               'hmm... let's add kamikaze pilots on windows
               IF RND(1)< .03 THEN

                  'check random slot. if already used, then search freeslot from start
                  free_slot_found = INT(RND(1)*4)
                  IF boss.windows(free_slot_found) THEN 'zomg! already used!
                     free_slot_found = -1
                     i = -1
                     DO
                        i += 1
                        IF boss.windows(i) = FALSE THEN free_slot_found = i
                     LOOP UNTIL free_slot_found >= 0 OR i>=3
                  END IF

                  IF free_slot_found > -1 THEN
                     boss.windows(free_slot_found) = TRUE
                     boss.windows_waiting(free_slot_found) = 30
                  END IF

               END IF


               'now add dangling kamikaze pilots on the window
               FOR j=0 TO 3
                  IF boss.windows(j) THEN


                     boss.windows_waiting(j) -= 1  'dangling
                     IF boss.windows_waiting(j) = 0 THEN   'then falling... banzai~!
                        boss.windows(j) = FALSE 'reset windows

                        'add actual kamikaze pilots
                        'search for empty kamikaze object
                        free_slot_found = -1
                        i = -1
                        DO
                           i += 1
                           IF kamikaze(i).used = FALSE THEN free_slot_found = i
                        LOOP UNTIL free_slot_found >= 0 OR i>=max_kamikaze

                        'set spike x,y, so it can be used rightaway
                        IF free_slot_found > -1 THEN
                           kamikaze(free_slot_found).used = TRUE
                           kamikaze(free_slot_found).x = boss.x+windows_offset(j)
                           kamikaze(free_slot_found).y = boss.y
                           KAMIKAZE(I).COUNTER = 0

                        END IF
                     END IF



                  END IF


               NEXT




            CASE st_boss_kamikaze 'not used
            CASE st_boss_spike 'not used

         END SELECT

         'adjust
         SELECT CASE octopus.state
            CASE st_follow_UFO
               octopus.x = boss.x
               octopus.y = boss.y - 40
            CASE st_fall
            CASE st_ZZZ
         END SELECT





         'BOSS display ----------------------------------------------------------------------------------
         IF boss.used THEN
            colorkey = &hc0c020

            PUT (boss.x-68, boss.y-31), boss_UFO, trans
            PUT (boss.x-69, boss.y-32), boss_frame, trans
            'SET(boss.x, boss.y):DRAW"NU3NR3ND3NL3"
            multiput (,octopus.x,octopus.y, sprite_buffer(4),2,2,0,254, @CUSTOM_MONO_PUT, @colorkey)

            'LINE(octopus.x-15,octopus.y-16)-(octopus.x+14,octopus.y+16),&HFF0000,b


         END IF


         '---< P L A Y E R  action >---------------------------------------------------------------------
         SELECT CASE player.state

            CASE st_init 'init
               player.state = st_move_in 'move in
               player.blink = 100
               player.x = 48
               player.y = 240
               player.hp = 5
               player.shot_fired = FALSE
               
            CASE st_move_in 'walk in
               player.y -= 2
               IF player.y <= 210 THEN
                  player.state = st_move 'action
               END IF

            CASE st_move
               'detect key and move some

               IF MULTIKEY(SC_LEFT) THEN 'range check needed
                  player.x -= 4
                  IF player.x <=16 THEN player.x = 16
               END IF

               IF MULTIKEY(SC_RIGHT) THEN 'range check needed
                  player.x += 4
                  IF player.x >= 304 THEN player.x = 304
               END IF

               'if space key
               IF MULTIKEY(SC_SPACE) AND NOT btn_hold THEN
                  IF NOT player.shot_fired THEN
                     player.shot_fired = TRUE
                     player.shot_x = player.x
                     player.shot_y = player.y-10
                     play_wav 1, 1,255 'tank fire sound

                     '       multiput (boss_UFO,INT(RND*136),INT(RND*62), sprite_buffer(16), 2,2,180,253,@CUSTOM_MASK_PUT)

                  END IF


               END IF



         END SELECT
         btn_hold = MULTIKEY(SC_SPACE)
         '--- end of player action ---





         '---<  T A N K  S H O T  processing >---
         IF player.shot_fired THEN

            player.shot_y -= 6

            IF player.shot_y < -10 THEN
               player.shot_fired = FALSE
            ELSE
               'all small enemy hit detection
               'and boss ufo hit detection
               'and connamder hit detection

               'if hit,     player.shot_fired = FALSE, enemy #n dead, score++  ,and some sound too

               'at the TIME of this, only BG and UFO is drawn. can use point to get UFO

               'if hit UFO
               IF (POINT (player.shot_x, player.shot_y) = &hdddddd) THEN
                  
                  IF super_weapon then
                  'eat ufo normal size
                  'multiput(boss_ufo, 68-(boss.x-player.shot_x),  31-(  boss.y-player.shot_y-3), sprite_buffer(16), 1 , 1 , 180 , 253, @CUSTOM_mask_PUT)
 
                  'eat ufo big
                  multiput(boss_ufo, 68-(boss.x-player.shot_x),  31-(  boss.y-player.shot_y-3), sprite_buffer(15), 2 , 2 , 180 , 253, @CUSTOM_mask_PUT)
                     play_wav 2,2,255
                  ELSE
                     ADD_PUFF(player.shot_x,player.shot_y,3)
                     play_wav 3,3,255
                  END if
                  player.shot_fired = FALSE


               END IF
               
               
               IF player.shot_fired THEN

                  'if hit with kamikaze
                  FOR i=0 TO MAX_kamikaze
                     IF kamikaze(i).used THEN


                        IF (player.shot_x >= kamikaze(i).x-9) AND _
                           (player.shot_x <= kamikaze(i).x+8) AND _
                           (player.shot_y >= kamikaze(i).y-10) AND _
                           (player.shot_y <= kamikaze(i).y+10) THEN   'actual hit detection

                           player.shot_fired = FALSE
                           kamikaze(i).used = false
                           play_wav 3,3,255
                           score += 10
                                                   IF score>hiscore THEN hiscore = score

                           ADD_PUFF(kamikaze(i).x,kamikaze(i).y,3)
                        END IF
                     END IF
                  NEXT
               END IF
               
               
               'if hit octopus
               IF player.shot_fired THEN

                  IF (player.shot_x >= octopus.x-15) AND _
                     (player.shot_x <= octopus.x+14) AND _
                     (player.shot_y >= octopus.y-16) AND _
                     (player.shot_y <= octopus.y+16) THEN   'actual hit detection

                     player.shot_fired = FALSE
                     win_timer = 100
                     play_wav 3,3,255
                     score += 1000
                        IF score>hiscore THEN hiscore = score

                     boss.state =    st_boss_ZZZ 'not used

                  END if
               END if

            END IF

         END IF

         IF win_timer >0 THEN
            IF win_timer mod 8 = 0 THEN
               ADD_PUFF (octopus.x + INT(RND(1) *20-10), octopus.y+ INT(RND(1) *10-5), 4)
               play_wav 2,2,255
            END IF
         END IF


         'kamikaze alien in the windows display ----------------------------------------------------------
         FOR j=0 TO 3
            IF boss.windows(j) THEN
               colorkey = &hff0000
               multiput (,boss.x + windows_offset(j), boss.y, sprite_buffer(0),  1,1,0,253,@CUSTOM_MONO_PUT, @colorkey)
            END IF
         NEXT

         'tank shot disply --------------------------------------------------------------------------------
         IF player.shot_fired THEN
            IF super_weapon THEN 
               colorkey = INT(RND(1)*&hffffff)
            ELSE
               colorkey = &hffff00
            END if
            MULTIPUT (,player.shot_x, player.shot_y, sprite_buffer(8), 3 , 3, 0 , 253, @CUSTOM_MONO_PUT, @colorkey)
            'PSET(player.shot_x, player.shot_y):DRAW"NU3NR3ND3NL3"
         END if


         ' kamikaze falling --------------------------------------------------------------------------------
         FOR i=0 TO MAX_kamikaze
            IF kamikaze(i).used THEN
               KAMIKAZE(I).COUNTER += 1

               kamikaze(i).y+=1
               IF KAMIKAZE(I).COUNTER > 10 THEN kamikaze(i).y+=1  'increase falling speed manually
               IF KAMIKAZE(I).COUNTER > 20 THEN kamikaze(i).y+=1
               IF KAMIKAZE(I).COUNTER > 30 THEN kamikaze(i).y+=1
               IF KAMIKAZE(I).COUNTER > 40 THEN kamikaze(i).y+=1
               IF KAMIKAZE(I).COUNTER > 50 THEN kamikaze(i).y+=1

               IF kamikaze(i).y>240 THEN
                  kamikaze(i).used= FALSE
               END IF

               IF player.state <> st_dead then
                  IF player.blink = 0 THEN  'player can only be hit when not blinking
                     IF (kamikaze(i).x >= player.x-22) AND _
                        (kamikaze(i).x <= player.x+18) AND _
                        (kamikaze(i).y >= player.y-14) AND _
                        (kamikaze(i).y <= player.y+10) THEN   'actual hit detection

                        kamikaze(i).used = FALSE
                        'player.hit = true
                        player.blink = 50

                        player.hp -= 1

                        IF player.hp <0 THEN

                           player.state = st_dead
                           gameover_timer = 100




                        END IF


                        play_wav 2,2,255
                        'dead set



                     END IF
                  END IF

               END IF



               colorkey = &hff0000
               multiput (,kamikaze(i).x, kamikaze(i).y, sprite_buffer(0), 2,2,0,253,@CUSTOM_MONO_PUT, @colorkey)
               'LINE(kamikaze(i).x-9, kamikaze(i).y-10)-(kamikaze(i).x+8, kamikaze(i).y+10),&H0000ff,b
               'PSET(kamikaze(i).x, kamikaze(i).y):DRAW"NU3NR3ND3NL3"

            END IF
         NEXT





         'process player blinking
         IF player.blink > 0 THEN
            player.blink -= 1
            IF player.blink = 0 THEN
               'end of blink. do something if needed
            END IF
         END IF

         'draw tank -----------------------------------------------------------------------------------------
         IF gameover_timer = 0 THEN
            IF player.blink = 0 OR ((player.blink \ 4) AND 1) THEN 'draw tank if not blinking
               colorkey = &hffff00
               MULTIPUT (,player.x, player.y, sprite_buffer(7), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)
               'LINE(player.x-22, player.y-14)-(player.x+18, player.y+10),&hff0000,b
            END IF
         ELSE
            colorkey = &hffff00
            MULTIPUT (,player.x, player.y, sprite_buffer(18 + ((gameover_timer\2) AND 1)), 2 , 2 , 0 ,253, @CUSTOM_MONO_PUT, @colorkey)
         END IF






 IF game_timer > 1000 AND game_timer <= 1030 THEN  
 
    squid.x = player.x+2
    squid.y = 230
            colorkey = &h008ff
            PUT (squid.x,squid.y), sprite_buffer(0), custom, @CUSTOM_MONO_PUT, @colorkey
 END IF 
 
 IF game_timer >1030 AND game_timer<= 1052 THEN
    squid.x = player.x+2
    squid.y -= 1
            colorkey = &h008ff
            PUT (squid.x,squid.y), sprite_buffer(0), custom, @CUSTOM_MONO_PUT, @colorkey
 
 '           colorkey = &h008ff
 '           PUT (player.x,player.y), sprite_buffer(0), custom, @CUSTOM_MONO_PUT, @colorkey
 '           LINE(player.x,player.y-40)-(player.x+86,player.y-16),&hffffff,bf
 '           colorkey = &hffffff
 '           multiput (,player.x+11 ,player.y-10, sprite_buffer(7),1,,180,254, @CUSTOM_MONO_PUT, @colorkey)
 '           TEXTDRAW (player.x+3,player.y-30,"it is done")
 END if 

 IF game_timer >1052 THEN
    squid.x = player.x +2
            colorkey = &h008ff
            PUT (squid.x,squid.y), sprite_buffer(0), custom, @CUSTOM_MONO_PUT, @colorkey
END if
 IF game_timer = 1052 THEN super_weapon = true







         DRAW_PUFF ()










         #IFDEF DEBUG

         #ENDIF


         IF warning>0 THEN
            warning -= 1
            IF warning = 0 THEN
               'end of warning. do something if needed...like BOSS appear init
               boss.state = st_boss_init
            END IF

            'from darius
            '     WARNING!
            ' A HUGE BATTLESHIP
            '    XXXXXXXX
            'IS APPROACHING FAST.

            'from blazing star
            '       WATCH OUT!
            '- THE BIG ONE IS CLOSING IN! -

            IF (warning < 180) AND (warning >  20) AND ((warning \ 20) MOD 3 > 0) THEN
               LINE(0,60)-(319,160),&hFF0000,bf
               TEXTDRAW (50+40,10+70  ,"     WARNING !     ")
               TEXTDRAW (50+40,40+70+2,"    A HUGE UFO     ")
               TEXTDRAW (50+40,70+70-5,"IS APPROACHING FAST")
            END IF
            'warning sound
            IF (warning <= 180) AND (warning >=  20) AND (warning  MOD 60 = 0) THEN play_wav 8,8,255
            IF (warning <= 180) AND (warning >=  20) AND (warning  MOD 60 = 20) THEN play_wav 8,8,0



         END IF

         'PUT (player.x-68,50-(player.x\8) MOD 10), boss_UFO, trans



         TEXTDRAW 8,3, "SCORE  " & zerofill( score,8) & "     HI SCORE  " & zerofill( hiscore,8), 0


         '         TEXTDRAW 1*8,28*8, "HP----grrrr add some HP"
         'diplay remaining tank
         IF player.hp < 5 THEN
            FOR i=1 TO player.hp
               TEXTDRAW i*16,29*8-6, CHR(22,23), &hFFFF00, FALSE
            NEXT
         ELSE
            TEXTDRAW 1*16,29*8-6, CHR(22,23), &hFFFF00, FALSE

            TEXTDRAW 32,29*8-6, " x " & zerofill( player.hp,2), 0
         END IF

         'credit
         TEXTDRAW 29*8,28*8, "credit " & zerofill( credit,2), 0
         LINE(0,240)-(399,299),0,bf 'border for 400x300 mode... if used...
         LINE(320,0)-(399,239),0,bf

   

         SCREENCOPY
         SWAP work_page, vis_page

SLEEP 30, 1

         'screensync


         IF result = flag_quit THEN ASK_QUIT(result) 'ask quit if esc was pressed



      LOOP UNTIL result <> flag_nothing  'game ended with some result

      WHILE INKEY <> "": WEND

      SCREENSET 0,0

      IF score = hiscore THEN SAVE_HISCORE(hiscore)
 


      IF result = flag_gameover THEN
         TEXTDRAW 88,90, "G A M E   O V E R", 0
         SLEEP 1000,1
         ASK_CONTINUE(game_continue)

      END IF



   LOOP WHILE game_continue   'loop exit condition : gameover/quit invader/win invader

   IF  result = flag_win THEN

      CUTSCENE 3 'ending demo
      
   END IF
   
   IMAGEDESTROY(boss_UFO)
   IMAGEDESTROY(boss_frame)


END SUB

